; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: This file contains procedures and data, that form the appearance of the
;               FreshLib GUI application. Colors, control borders, backgrownd drawing etc.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: The user should be able to change these settings and if he uses external
;         procedures, then the code from this library should not be compiled.
;_________________________________________________________________________________________
module "GUI theme data and code library"

; Box border type
bxNone   = 0
bxRaised = 1
bxSunken = 2
bxFlat   = 3
bxNoFill = $80000000

; Default colors
iglobal
  var clBorderLight   = $ffffff
  var clBorderDark    = $606060 ; soft shadow
  var clBorderNeutral = $a0a0a8

  var clEditBk        = $fffff0
  var clEditTxt       = $000000
  var clEditSel       = $0000a0
  var clEditSelTxt    = $ffffff

  var clButtonBk      = $d0d0d8
  var clButtonTxt     = $000000

  var clButtonHotBk   = $e0e0e8
  var clButtonHotTxt  = $0000ff

  var clDialogBk      = $d0d0d8
  var clDialogTxt     = $000000

  var clScrollBk      = $a0a0a0
  var clScrollSlider  = $d0d0d8

  if ~defined DrawBox | defined ___DrawBox
    var DrawBox = DrawBoxDefault
    ___DrawBox = 1
  end if

  if ~defined DrawSlider | defined ___DrawSlider
    var DrawSlider = DrawSliderDefault
    ___DrawSlider = 1
  end if


endg





; Midnight colors
;iglobal
;  var clBorderLight   = $0000ff
;  var clBorderDark    = $000000
;  var clBorderNeutral = $808080
;
;  var clEditBk        = $0000c0
;  var clEditTxt       = $ffffff
;  var clEditSel       = $0000ff
;  var clEditSelTxt    = $000000
;
;  var clButtonBk      = $000080
;  var clButtonTxt     = $ffffff
;
;  var clButtonHotBk   = $0000a0
;  var clButtonHotTxt  = $ffffff
;
;  var clDialogBk      = $000080
;  var clDialogTxt     = $ffffff
;endg




proc DrawBoxDefault, .context, .pBounds, .bkground, .border
  .brd RECT
begin
        push    eax ecx edx esi


        stdcall SetDrawMode, [.context], cmCopy

        mov     esi, [.pBounds]

        mov     edx, [.border]
        and     edx, $ff
        jz      .borderok

        mov     eax, [esi+TBounds.x]
        mov     ecx, [esi+TBounds.y]
        mov     [.brd.left], eax
        mov     [.brd.top], ecx

        add     eax, [esi+TBounds.width]
        add     ecx, [esi+TBounds.height]
        dec     eax
        dec     ecx
        mov     [.brd.right], eax
        mov     [.brd.bottom], ecx

        sub     [esi+TBounds.width], 2
        sub     [esi+TBounds.height], 2
        inc     [esi+TBounds.x]
        inc     [esi+TBounds.y]

        mov     eax, [clBorderLight]
        mov     ecx, [clBorderDark]

        cmp     edx, bxRaised
        je      .colorok

        xchg    eax, ecx

        cmp     edx, bxSunken
        je      .colorok

        mov     eax, [clBorderNeutral]
        mov     ecx, eax

.colorok:
        stdcall SetSimpleLine, [.context], eax
        stdcall DrawLine, [.context], [.brd.left],  [.brd.top], [.brd.left], [.brd.bottom]
        stdcall DrawLine, [.context], [.brd.left],  [.brd.top], [.brd.right], [.brd.top]

        stdcall SetSimpleLine, [.context], ecx
        stdcall DrawLine, [.context], [.brd.left], [.brd.bottom], [.brd.right], [.brd.bottom]
        inc      [.brd.bottom]
        stdcall DrawLine, [.context], [.brd.right], [.brd.top], [.brd.right], [.brd.bottom]

.borderok:
        bt      [.border], 31
        jc      .fillok
        stdcall DrawFillRect, [.context], [esi+TBounds.x], [esi+TBounds.y], [esi+TBounds.width], [esi+TBounds.height], [.bkground]

; additional 1px margin
        sub     [esi+TBounds.width], 2
        sub     [esi+TBounds.height], 2
        inc     [esi+TBounds.x]
        inc     [esi+TBounds.y]

.fillok:
        pop     esi edx ecx eax
        return
endp


sliderHorizontal = 0
sliderVertical   = 1

proc DrawSliderDefault, .context, .pBounds, .bkground, .type
begin
        stdcall [DrawBox], [.context], [.pBounds], [.bkground], bxRaised
        return
endp



endmodule