; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: All GUI libraries combined include.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes: Includes all GUI libraries at once.
;_________________________________________________________________________________________

AlignLeft   = 0
AlignRight  = 1
AlignTop    = 2
AlignBottom = 3

include 'sysevents.asm'

include 'mouse.asm'
include 'textcaret.asm'

; OS independent support code
include 'objects.asm'
include 'TAction.asm'

; OS independent template engine.
include 'ObjTemplates.asm'

; Limited support for the old visual editor. Contains only macro definitions.
include 'OldTemplates.inc'

; OS independent components
include 'TObject.asm'
include 'TWindow.asm'
include 'TScrollWindow.asm'

include 'TApplication.asm'
include 'TForm.asm'
include 'TButton.asm'
include 'TEdit.asm'
include 'TLabel.asm'
include 'TImageLabel.asm'
include 'TMenuItem.asm'
include 'TMenu.asm'
include 'TProgressbar.asm'
include 'TTreeView.asm'
include 'TGrid.asm'

include 'ThemeGUI.asm'

include 'dialogs.asm'

; OS independent main procedures.
include 'Main.asm'
