; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: odbc32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

import_proto odbc32,  \
    CloseODBCPerfData, <NONE>,  'CloseODBCPerfData',  \
    CollectODBCPerfData, <NONE>,  'CollectODBCPerfData',  \
    CursorLibLockDbc, <NONE>,  'CursorLibLockDbc',  \
    CursorLibLockDesc, <NONE>,  'CursorLibLockDesc',  \
    CursorLibLockStmt, <NONE>,  'CursorLibLockStmt',  \
    CursorLibTransact, <NONE>,  'CursorLibTransact',  \
    GetODBCSharedData, <NONE>,  'GetODBCSharedData',  \
    LockHandle, <NONE>,  'LockHandle',  \
    MpHeapAlloc, <NONE>,  'MpHeapAlloc',  \
    MpHeapCompact, <NONE>,  'MpHeapCompact',  \
    MpHeapCreate, <NONE>,  'MpHeapCreate',  \
    MpHeapDestroy, <NONE>,  'MpHeapDestroy',  \
    MpHeapFree, <NONE>,  'MpHeapFree',  \
    MpHeapReAlloc, <NONE>,  'MpHeapReAlloc',  \
    MpHeapSize, <NONE>,  'MpHeapSize',  \
    MpHeapValidate, <NONE>,  'MpHeapValidate',  \
    ODBCGetTryWaitValue, <VOID>,  'ODBCGetTryWaitValue',  \
    ODBCInternalConnectW, <NONE>,  'ODBCInternalConnectW',  \
    ODBCQualifyFileDSNW, <NONE>,  'ODBCQualifyFileDSNW',  \
    ODBCSetTryWaitValue, <.dwValue>,  'ODBCSetTryWaitValue',  \
    OpenODBCPerfData, <NONE>,  'OpenODBCPerfData',  \
    PostComponentError, <NONE>,  'PostComponentError',  \
    PostODBCComponentError, <NONE>,  'PostODBCComponentError',  \
    PostODBCError, <NONE>,  'PostODBCError',  \
    SQLAllocConnect, <.henv, .phdbc>,  'SQLAllocConnect',  \
    SQLAllocEnv, <.phenv>,  'SQLAllocEnv',  \
    SQLAllocHandle, <.HandleType, .InputHandle, .OutputHandle>,  'SQLAllocHandle',  \
    SQLAllocHandleStd, <.fHandleType, .hInput, .phOutput>,  'SQLAllocHandleStd',  \
    SQLAllocStmt, <.hdbc, .phstmt>,  'SQLAllocStmt',  \
    SQLBindCol, <.hstmt, .icol, .fCType, .rgbValue, .cbValueMax, .pcbValue>,  'SQLBindCol',  \
    SQLBindParam, <.StatementHandle, .ParameterNumber, .ValueType, .ParameterType, .LengthPrecision, .ParameterScale, .ParameterValue,  \
        .StrLen_or_Ind>,  'SQLBindParam',  \
    SQLBindParameter, <.hstmt, .ipar, .fParamType, .fCType, .fSqlType, .cbColDef, .ibScale, .rgbValue, .cbValueMax, .pcbValue>,  'SQLBindParameter',  \
    SQLBrowseConnect, <.hdbc, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut>,  'SQLBrowseConnect',  \
    SQLBrowseConnectA, <.hdbc, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut>,  'SQLBrowseConnectA',  \
    SQLBrowseConnectW, <.hdbc, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut>,  'SQLBrowseConnectW',  \
    SQLBulkOperations, <.StatementHandle, .Operation>,  'SQLBulkOperations',  \
    SQLCancel, <.hstmt>,  'SQLCancel',  \
    SQLCloseCursor, <.StatementHandle>,  'SQLCloseCursor',  \
    SQLColAttribute, <.hstmt, .iCol, .iField, .pCharAttr, .cbCharAttrMax, .pcbCharAttr, .pNumAttr>,  'SQLColAttribute',  \
    SQLColAttributeA, <.hstmt, .iCol, .iField, .pCharAttr, .cbCharAttrMax, .pcbCharAttr, .pNumAttr>,  'SQLColAttributeA',  \
    SQLColAttributeW, <.hstmt, .iCol, .iField, .pCharAttr, .cbCharAttrMax, .pcbCharAttr, .pNumAttr>,  'SQLColAttributeW',  \
    SQLColAttributes, <.hstmt, .icol, .fDescType, .rgbDesc, .cbDescMax, .pcbDesc, .pfDesc>,  'SQLColAttributes',  \
    SQLColAttributesA, <.hstmt, .icol, .fDescType, .rgbDesc, .cbDescMax, .pcbDesc, .pfDesc>,  'SQLColAttributesA',  \
    SQLColAttributesW, <.hstmt, .icol, .fDescType, .rgbDesc, .cbDescMax, .pcbDesc, .pfDesc>,  'SQLColAttributesW',  \
    SQLColumnPrivileges, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName,  \
        .cbColumnName>,  'SQLColumnPrivileges',  \
    SQLColumnPrivilegesA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName,  \
        .cbColumnName>,  'SQLColumnPrivilegesA',  \
    SQLColumnPrivilegesW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName,  \
        .cbColumnName>,  'SQLColumnPrivilegesW',  \
    SQLColumns, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName, .cbColumnName,  \
      >,  'SQLColumns',  \
    SQLColumnsA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName,  \
        .cbColumnName>,  'SQLColumnsA',  \
    SQLColumnsW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szColumnName,  \
        .cbColumnName>,  'SQLColumnsW',  \
    SQLConnect, <.hdbc, .szDSN, .cbDSN, .szUID, .cbUID, .szAuthStr, .cbAuthStr>,  'SQLConnect',  \
    SQLConnectA, <.hdbc, .szDSN, .cbDSN, .szUID, .cbUID, .szAuthStr, .cbAuthStr>,  'SQLConnectA',  \
    SQLConnectW, <.hdbc, .szDSN, .cbDSN, .szUID, .cbUID, .szAuthStr, .cbAuthStr>,  'SQLConnectW',  \
    SQLCopyDesc, <.SourceDescHandle, .TargetDescHandle>,  'SQLCopyDesc',  \
    SQLDataSources, <.henv, .fDirection, .szDSN, .cbDSNMax, .pcbDSN, .szDescription, .cbDescriptionMax, .pcbDescription>,  'SQLDataSources',  \
    SQLDataSourcesA, <.henv, .fDirection, .szDSN, .cbDSNMax, .pcbDSN, .szDescription, .cbDescriptionMax, .pcbDescription>,  'SQLDataSourcesA',  \
    SQLDataSourcesW, <.henv, .fDirection, .szDSN, .cbDSNMax, .pcbDSN, .szDescription, .cbDescriptionMax, .pcbDescription>,  'SQLDataSourcesW',  \
    SQLDescribeCol, <.hstmt, .icol, .szColName, .cbColNameMax, .pcbColName, .pfSqlType, .pcbColDef, .pibScale, .pfNullable>,  'SQLDescribeCol',  \
    SQLDescribeColA, <.hstmt, .icol, .szColName, .cbColNameMax, .pcbColName, .pfSqlType, .pcbColDef, .pibScale, .pfNullable>,  'SQLDescribeColA',  \
    SQLDescribeColW, <.hstmt, .icol, .szColName, .cbColNameMax, .pcbColName, .pfSqlType, .pcbColDef, .pibScale, .pfNullable>,  'SQLDescribeColW',  \
    SQLDescribeParam, <.hstmt, .ipar, .pfSqlType, .pcbParamDef, .pibScale, .pfNullable>,  'SQLDescribeParam',  \
    SQLDisconnect, <.hdbc>,  'SQLDisconnect',  \
    SQLDriverConnect, <.hdbc, .hwnd, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut, .fDriverCompletion,  \
      >,  'SQLDriverConnect',  \
    SQLDriverConnectA, <.hdbc, .hwnd, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut, .fDriverCompletion,  \
      >,  'SQLDriverConnectA',  \
    SQLDriverConnectW, <.hdbc, .hwnd, .szConnStrIn, .cbConnStrIn, .szConnStrOut, .cbConnStrOutMax, .pcbConnStrOut, .fDriverCompletion,  \
      >,  'SQLDriverConnectW',  \
    SQLDrivers, <.henv, .fDirection, .szDriverDesc, .cbDriverDescMax, .pcbDriverDesc, .szDriverAttributes, .cbDrvrAttrMax, .pcbDrvrAttr,  \
      >,  'SQLDrivers',  \
    SQLDriversA, <.henv, .fDirection, .szDriverDesc, .cbDriverDescMax, .pcbDriverDesc, .szDriverAttributes, .cbDrvrAttrMax, .pcbDrvrAttr,  \
      >,  'SQLDriversA',  \
    SQLDriversW, <.henv, .fDirection, .szDriverDesc, .cbDriverDescMax, .pcbDriverDesc, .szDriverAttributes, .cbDrvrAttrMax, .pcbDrvrAttr,  \
      >,  'SQLDriversW',  \
    SQLEndTran, <.HandleType, .handle, .CompletionType>,  'SQLEndTran',  \
    SQLError, <.henv, .hdbc, .hstmt, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLError',  \
    SQLErrorA, <.henv, .hdbc, .hstmt, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLErrorA',  \
    SQLErrorW, <.henv, .hdbc, .hstmt, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLErrorW',  \
    SQLExecDirect, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLExecDirect',  \
    SQLExecDirectA, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLExecDirectA',  \
    SQLExecDirectW, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLExecDirectW',  \
    SQLExecute, <.hstmt>,  'SQLExecute',  \
    SQLExtendedFetch, <.hstmt, .fFetchType, .irow, .pcrow, .rgfRowStatus>,  'SQLExtendedFetch',  \
    SQLFetch, <.hstmt>,  'SQLFetch',  \
    SQLFetchScroll, <.StatementHandle, .FetchOrientation, .FetchOffset>,  'SQLFetchScroll',  \
    SQLForeignKeys, <.hstmt, .szPkCatalogName, .cbPkCatalogName, .szPkSchemaName, .cbPkSchemaName, .szPkTableName, .cbPkTableName,  \
        .szFkCatalogName, .cbFkCatalogName, .szFkSchemaName, .cbFkSchemaName, .szFkTableName, .cbFkTableName>,  'SQLForeignKeys',  \
    SQLForeignKeysA, <.hstmt, .szPkCatalogName, .cbPkCatalogName, .szPkSchemaName, .cbPkSchemaName, .szPkTableName, .cbPkTableName,  \
        .szFkCatalogName, .cbFkCatalogName, .szFkSchemaName, .cbFkSchemaName, .szFkTableName, .cbFkTableName>,  'SQLForeignKeysA',  \
    SQLForeignKeysW, <.hstmt, .szPkCatalogName, .cbPkCatalogName, .szPkSchemaName, .cbPkSchemaName, .szPkTableName, .cbPkTableName,  \
        .szFkCatalogName, .cbFkCatalogName, .szFkSchemaName, .cbFkSchemaName, .szFkTableName, .cbFkTableName>,  'SQLForeignKeysW',  \
    SQLFreeConnect, <.hdbc>,  'SQLFreeConnect',  \
    SQLFreeEnv, <.henv>,  'SQLFreeEnv',  \
    SQLFreeHandle, <.HandleType, .handle>,  'SQLFreeHandle',  \
    SQLFreeStmt, <.hstmt, .fOption>,  'SQLFreeStmt',  \
    SQLGetConnectAttr, <.ConnectionHandle, .lAttribute, .lValue, .BufferLength, .StringLength>,  'SQLGetConnectAttr',  \
    SQLGetConnectAttrA, <.ConnectionHandle, .lAttribute, .lValue, .BufferLength, .StringLength>,  'SQLGetConnectAttrA',  \
    SQLGetConnectAttrW, <.ConnectionHandle, .lAttribute, .lValue, .BufferLength, .StringLength>,  'SQLGetConnectAttrW',  \
    SQLGetConnectOption, <.hdbc, .fOption, .pvParam>,  'SQLGetConnectOption',  \
    SQLGetConnectOptionA, <.hdbc, .fOption, .pvParam>,  'SQLGetConnectOptionA',  \
    SQLGetConnectOptionW, <.hdbc, .fOption, .pvParam>,  'SQLGetConnectOptionW',  \
    SQLGetCursorName, <.hstmt, .szCursor, .cbCursorMax, .pcbCursor>,  'SQLGetCursorName',  \
    SQLGetCursorNameA, <.hstmt, .szCursor, .cbCursorMax, .pcbCursor>,  'SQLGetCursorNameA',  \
    SQLGetCursorNameW, <.hstmt, .szCursor, .cbCursorMax, .pcbCursor>,  'SQLGetCursorNameW',  \
    SQLGetData, <.hstmt, .icol, .fCType, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetData',  \
    SQLGetDescField, <.hdesc, .iRecord, .iField, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetDescField',  \
    SQLGetDescFieldA, <.hdesc, .iRecord, .iField, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetDescFieldA',  \
    SQLGetDescFieldW, <.hdesc, .iRecord, .iField, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetDescFieldW',  \
    SQLGetDescRec, <.hdesc, .iRecord, .szName, .cbNameMax, .pcbName, .pfType, .pfSubType, .pLength, .pPrecision, .pScale, .pNullable,  \
      >,  'SQLGetDescRec',  \
    SQLGetDescRecA, <.hdesc, .iRecord, .szName, .cbNameMax, .pcbName, .pfType, .pfSubType, .pLength, .pPrecision, .pScale, .pNullable,  \
      >,  'SQLGetDescRecA',  \
    SQLGetDescRecW, <.hdesc, .iRecord, .szName, .cbNameMax, .pcbName, .pfType, .pfSubType, .pLength, .pPrecision, .pScale, .pNullable,  \
      >,  'SQLGetDescRecW',  \
    SQLGetDiagField, <.HandleType, .handle, .RecNumber, .DiagIdentifier, .DiagInfo, .BufferLength, .StringLength>,  'SQLGetDiagField',  \
    SQLGetDiagFieldA, <.HandleType, .handle, .RecNumber, .DiagIdentifier, .DiagInfo, .BufferLength, .StringLength>,  'SQLGetDiagFieldA',  \
    SQLGetDiagFieldW, <.HandleType, .handle, .RecNumber, .DiagIdentifier, .DiagInfo, .BufferLength, .StringLength>,  'SQLGetDiagFieldW',  \
    SQLGetDiagRec, <.fHandleType, .handle, .iRecord, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLGetDiagRec',  \
    SQLGetDiagRecA, <.fHandleType, .handle, .iRecord, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLGetDiagRecA',  \
    SQLGetDiagRecW, <.fHandleType, .handle, .iRecord, .szSqlState, .pfNativeError, .szErrorMsg, .cbErrorMsgMax, .pcbErrorMsg>,  'SQLGetDiagRecW',  \
    SQLGetEnvAttr, <.EnvironmentHandle, .lAttribute, .lValue, .BufferLength, .StringLength>,  'SQLGetEnvAttr',  \
    SQLGetFunctions, <.hdbc, .fFunction, .pfExists>,  'SQLGetFunctions',  \
    SQLGetInfo, <.hdbc, .fInfoType, .rgbInfoValue, .cbInfoValueMax, .pcbInfoValue>,  'SQLGetInfo',  \
    SQLGetInfoA, <.hdbc, .fInfoType, .rgbInfoValue, .cbInfoValueMax, .pcbInfoValue>,  'SQLGetInfoA',  \
    SQLGetInfoW, <.hdbc, .fInfoType, .rgbInfoValue, .cbInfoValueMax, .pcbInfoValue>,  'SQLGetInfoW',  \
    SQLGetStmtAttr, <.hstmt, .fAttribute, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetStmtAttr',  \
    SQLGetStmtAttrA, <.hstmt, .fAttribute, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetStmtAttrA',  \
    SQLGetStmtAttrW, <.hstmt, .fAttribute, .rgbValue, .cbValueMax, .pcbValue>,  'SQLGetStmtAttrW',  \
    SQLGetStmtOption, <.hstmt, .fOption, .pvParam>,  'SQLGetStmtOption',  \
    SQLGetTypeInfo, <.hstmt, .fSqlType>,  'SQLGetTypeInfo',  \
    SQLGetTypeInfoA, <.hstmt, .fSqlType>,  'SQLGetTypeInfoA',  \
    SQLGetTypeInfoW, <.hstmt, .fSqlType>,  'SQLGetTypeInfoW',  \
    SQLMoreResults, <.hstmt>,  'SQLMoreResults',  \
    SQLNativeSql, <.hdbc, .szSqlStrIn, .cbSqlStrIn, .szSqlStr, .cbSqlStrMax, .pcbSqlStr>,  'SQLNativeSql',  \
    SQLNativeSqlA, <.hdbc, .szSqlStrIn, .cbSqlStrIn, .szSqlStr, .cbSqlStrMax, .pcbSqlStr>,  'SQLNativeSqlA',  \
    SQLNativeSqlW, <.hdbc, .szSqlStrIn, .cbSqlStrIn, .szSqlStr, .cbSqlStrMax, .pcbSqlStr>,  'SQLNativeSqlW',  \
    SQLNumParams, <.hstmt, .pcpar>,  'SQLNumParams',  \
    SQLNumResultCols, <.hstmt, .pccol>,  'SQLNumResultCols',  \
    SQLParamData, <.hstmt, .prgbValue>,  'SQLParamData',  \
    SQLParamOptions, <.hstmt, .crow, .pirow>,  'SQLParamOptions',  \
    SQLPrepare, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLPrepare',  \
    SQLPrepareA, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLPrepareA',  \
    SQLPrepareW, <.hstmt, .szSqlStr, .cbSqlStr>,  'SQLPrepareW',  \
    SQLPrimaryKeys, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLPrimaryKeys',  \
    SQLPrimaryKeysA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLPrimaryKeysA',  \
    SQLPrimaryKeysW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLPrimaryKeysW',  \
    SQLProcedureColumns, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName, .szColumnName,  \
        .cbColumnName>,  'SQLProcedureColumns',  \
    SQLProcedureColumnsA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName, .szColumnName,  \
        .cbColumnName>,  'SQLProcedureColumnsA',  \
    SQLProcedureColumnsW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName, .szColumnName,  \
        .cbColumnName>,  'SQLProcedureColumnsW',  \
    SQLProcedures, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName>,  'SQLProcedures',  \
    SQLProceduresA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName>,  'SQLProceduresA',  \
    SQLProceduresW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szProcName, .cbProcName>,  'SQLProceduresW',  \
    SQLPutData, <.hstmt, .rgbValue, .cbValue>,  'SQLPutData',  \
    SQLRowCount, <.hstmt, .pcrow>,  'SQLRowCount',  \
    SQLSetConnectAttr, <.hdbc, .fAttribute, .rgbValue, .cbValue>,  'SQLSetConnectAttr',  \
    SQLSetConnectAttrA, <.hdbc, .fAttribute, .rgbValue, .cbValue>,  'SQLSetConnectAttrA',  \
    SQLSetConnectAttrW, <.hdbc, .fAttribute, .rgbValue, .cbValue>,  'SQLSetConnectAttrW',  \
    SQLSetConnectOption, <.hdbc, .fOption, .vParam>,  'SQLSetConnectOption',  \
    SQLSetConnectOptionA, <.hdbc, .fOption, .vParam>,  'SQLSetConnectOptionA',  \
    SQLSetConnectOptionW, <.hdbc, .fOption, .vParam>,  'SQLSetConnectOptionW',  \
    SQLSetCursorName, <.hstmt, .szCursor, .cbCursor>,  'SQLSetCursorName',  \
    SQLSetCursorNameA, <.hstmt, .szCursor, .cbCursor>,  'SQLSetCursorNameA',  \
    SQLSetCursorNameW, <.hstmt, .szCursor, .cbCursor>,  'SQLSetCursorNameW',  \
    SQLSetDescField, <.DescriptorHandle, .RecNumber, .FieldIdentifier, .Value, .BufferLength>,  'SQLSetDescField',  \
    SQLSetDescFieldA, <.DescriptorHandle, .RecNumber, .FieldIdentifier, .Value, .BufferLength>,  'SQLSetDescFieldA',  \
    SQLSetDescFieldW, <.DescriptorHandle, .RecNumber, .FieldIdentifier, .Value, .BufferLength>,  'SQLSetDescFieldW',  \
    SQLSetDescRec, <.DescriptorHandle, .RecNumber, .lType, .SubType, .Length, .Precision, .kScale, .Data, .StringLength, .Indicator,  \
      >,  'SQLSetDescRec',  \
    SQLSetEnvAttr, <.EnvironmentHandle, .lAttribute, .Value, .StringLength>,  'SQLSetEnvAttr',  \
    SQLSetParam, <.hstmt, .ipar, .fCType, .fSqlType, .cbParamDef, .ibScale, .rgbValue, .pcbValue>,  'SQLSetParam',  \
    SQLSetPos, <.hstmt, .irow, .fOption, .fLock>,  'SQLSetPos',  \
    SQLSetScrollOptions, <.hstmt, .fConcurrency, .crowKeyset, .crowRowset>,  'SQLSetScrollOptions',  \
    SQLSetStmtAttr, <.StatementHandle, .lAttribute, .Value, .StringLength>,  'SQLSetStmtAttr',  \
    SQLSetStmtAttrA, <.StatementHandle, .lAttribute, .Value, .StringLength>,  'SQLSetStmtAttrA',  \
    SQLSetStmtAttrW, <.StatementHandle, .lAttribute, .Value, .StringLength>,  'SQLSetStmtAttrW',  \
    SQLSetStmtOption, <.hstmt, .fOption, .vParam>,  'SQLSetStmtOption',  \
    SQLSpecialColumns, <.hstmt, .fColType, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName,  \
        .fScope, .fNullable>,  'SQLSpecialColumns',  \
    SQLSpecialColumnsA, <.hstmt, .fColType, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName,  \
        .fScope, .fNullable>,  'SQLSpecialColumnsA',  \
    SQLSpecialColumnsW, <.hstmt, .fColType, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName,  \
        .fScope, .fNullable>,  'SQLSpecialColumnsW',  \
    SQLStatistics, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .fUnique, .fAccuracy,  \
      >,  'SQLStatistics',  \
    SQLStatisticsA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .fUnique, .fAccuracy,  \
      >,  'SQLStatisticsA',  \
    SQLStatisticsW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .fUnique, .fAccuracy,  \
      >,  'SQLStatisticsW',  \
    SQLTablePrivileges, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLTablePrivileges',  \
    SQLTablePrivilegesA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLTablePrivilegesA',  \
    SQLTablePrivilegesW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName>,  'SQLTablePrivilegesW',  \
    SQLTables, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szTableType, .cbTableType,  \
      >,  'SQLTables',  \
    SQLTablesA, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szTableType, .cbTableType,  \
      >,  'SQLTablesA',  \
    SQLTablesW, <.hstmt, .szCatalogName, .cbCatalogName, .szSchemaName, .cbSchemaName, .szTableName, .cbTableName, .szTableType, .cbTableType,  \
      >,  'SQLTablesW',  \
    SQLTransact, <.henv, .hdbc, .fType>,  'SQLTransact',  \
    SearchStatusCode, <NONE>,  'SearchStatusCode',  \
    VFreeErrors, <NONE>,  'VFreeErrors',  \
    VRetrieveDriverErrorsRowCol, <NONE>,  'VRetrieveDriverErrorsRowCol',  \
    ValidateErrorQueue, <NONE>,  'ValidateErrorQueue',  \
    g_hHeapMalloc, <NONE>,  'g_hHeapMalloc'
