; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: user32.dll API calls
;
;  Target OS: Win32
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

;   user32.dll API calls
import_proto user32,  \
    ActivateKeyboardLayout, <.HKL, .flags>,  'ActivateKeyboardLayout',  \
    AdjustWindowRect, <.lpRect, .dwStyle, .bMenu>,  'AdjustWindowRect',  \
    AdjustWindowRectEx, <.lpRect, .dwStyle, .bMenu, .dwExStyle>,  'AdjustWindowRectEx',  \
    AlignRects, <NONE>,  'AlignRects',  \
    AllowForegroundActivation, <NONE>,  'AllowForegroundActivation',  \
    AllowSetForegroundWindow, <.dwProcessId>,  'AllowSetForegroundWindow',  \
    AnimateWindow, <.hwnd, .dwTime, .dwFlags>,  'AnimateWindow',  \
    AnyPopup, <VOID>,  'AnyPopup',  \
    AppendMenuA, <.hMenu, .wFlags, .wIDNewItem, .lpNewItem>,  'AppendMenuA',  \
    AppendMenuW, <.hMenu, .wFlags, .wIDNewItem, .lpNewItem>,  'AppendMenuW',  \
    ArrangeIconicWindows, <.hwnd>,  'ArrangeIconicWindows',  \
    AttachThreadInput, <.idAttach, .idAttachTo, .fAttach>,  'AttachThreadInput',  \
    BeginDeferWindowPos, <.nNumWindows>,  'BeginDeferWindowPos',  \
    BeginPaint, <.hwnd, .lpPaint>,  'BeginPaint',  \
    BlockInput, <.fBlockIt>,  'BlockInput',  \
    BringWindowToTop, <.hwnd>,  'BringWindowToTop',  \
    BroadcastSystemMessage, <.dw, .pdw, .un, .wParam, .lParam>,  'BroadcastSystemMessage',  \
    BroadcastSystemMessageA, <.dw, .pdw, .un, .wParam, .lParam>,  'BroadcastSystemMessageA',  \
    BroadcastSystemMessageExA, <NONE>,  'BroadcastSystemMessageExA',  \
    BroadcastSystemMessageExW, <NONE>,  'BroadcastSystemMessageExW',  \
    BroadcastSystemMessageW, <.dw, .pdw, .un, .wParam, .lParam>,  'BroadcastSystemMessageW',  \
    BuildReasonArray, <NONE>,  'BuildReasonArray',  \
    CalcMenuBar, <NONE>,  'CalcMenuBar',  \
    CallMsgFilter, <.lpMsg, .ncode>,  'CallMsgFilter',  \
    CallMsgFilterA, <.lpMsg, .ncode>,  'CallMsgFilterA',  \
    CallMsgFilterW, <.lpMsg, .ncode>,  'CallMsgFilterW',  \
    CallNextHookEx, <.hHook, .ncode, .wParam, .lParam>,  'CallNextHookEx',  \
    CallWindowProcA, <.lpPrevWndFunc, .hWnd, .Msg, .wParam, .lParam>,  'CallWindowProcA',  \
    CallWindowProcW, <.lpPrevWndFunc, .hWnd, .Msg, .wParam, .lParam>,  'CallWindowProcW',  \
    CascadeChildWindows, <NONE>,  'CascadeChildWindows',  \
    CascadeWindows, <.hwndParent, .wHow, .lpRect, .cKids, .lpkids>,  'CascadeWindows',  \
    ChangeClipboardChain, <.hwnd, .hWndNext>,  'ChangeClipboardChain',  \
    ChangeDisplaySettingsA, <.lpDevMode, .dwFlags>,  'ChangeDisplaySettingsA',  \
    ChangeDisplaySettingsExA, <.lpszDeviceName, .lpDevMode, .hwnd, .dwflags, .lParam>,  'ChangeDisplaySettingsExA',  \
    ChangeDisplaySettingsExW, <.lpszDeviceName, .lpDevMode, .hwnd, .dwflags, .lParam>,  'ChangeDisplaySettingsExW',  \
    ChangeDisplaySettingsW, <.lpDevMode, .dwFlags>,  'ChangeDisplaySettingsW',  \
    ChangeMenuA, <.hMenu, .cmd, .lpszNewItem, .cmdInsert, .flags>,  'ChangeMenuA',  \
    ChangeMenuW, <.hMenu, .cmd, .lpszNewItem, .cmdInsert, .flags>,  'ChangeMenuW',  \
    CharLowerA, <.lpsz>,  'CharLowerA',  \
    CharLowerBuffA, <.lpsz, .cchLength>,  'CharLowerBuffA',  \
    CharLowerBuffW, <.lpsz, .cchLength>,  'CharLowerBuffW',  \
    CharLowerW, <.lpsz>,  'CharLowerW',  \
    CharNextA, <.lpsz>,  'CharNextA',  \
    CharNextExA, <.CodePage, .lpCurrentChar, .dwFlags>,  'CharNextExA',  \
    CharNextW, <.lpsz>,  'CharNextW',  \
    CharPrevA, <.lpszStart, .lpszCurrent>,  'CharPrevA',  \
    CharPrevExA, <.CodePage, .lpStart, .lpCurrentChar, .dwFlags>,  'CharPrevExA',  \
    CharPrevW, <.lpszStart, .lpszCurrent>,  'CharPrevW',  \
    CharToOemA, <.lpszSrc, .lpszDst>,  'CharToOemA',  \
    CharToOemBuffA, <.lpszSrc, .lpszDst, .cchDstLength>,  'CharToOemBuffA',  \
    CharToOemBuffW, <.lpszSrc, .lpszDst, .cchDstLength>,  'CharToOemBuffW',  \
    CharToOemW, <.lpszSrc, .lpszDst>,  'CharToOemW',  \
    CharUpperA, <.lpsz>,  'CharUpperA',  \
    CharUpperBuffA, <.lpsz, .cchLength>,  'CharUpperBuffA',  \
    CharUpperBuffW, <.lpsz, .cchLength>,  'CharUpperBuffW',  \
    CharUpperW, <.lpsz>,  'CharUpperW',  \
    CheckDlgButton, <.hDlg, .nIDButton, .uCheck>,  'CheckDlgButton',  \
    CheckMenuItem, <.hMenu, .wIDCheckItem, .wCheck>,  'CheckMenuItem',  \
    CheckMenuRadioItem, <.hMenu, .un1, .un2, .un3, .un4>,  'CheckMenuRadioItem',  \
    CheckRadioButton, <.hDlg, .nIDFirstButton, .nIDLastButton, .nIDCheckButton>,  'CheckRadioButton',  \
    ChildWindowFromPoint, <.hWnd, .xPoint, .yPoint>,  'ChildWindowFromPoint',  \
    ChildWindowFromPointEx, <.hWnd, .pt, .un>,  'ChildWindowFromPointEx',  \
    CliImmSetHotKey, <NONE>,  'CliImmSetHotKey',  \
    ClientThreadSetup, <NONE>,  'ClientThreadSetup',  \
    ClientToScreen, <.hwnd, .lpPoint>,  'ClientToScreen',  \
    ClipCursor, <.lpRect>,  'ClipCursor',  \
    CloseClipboard, <VOID>,  'CloseClipboard',  \
    CloseDesktop, <.hDesktop>,  'CloseDesktop',  \
    CloseWindow, <.hwnd>,  'CloseWindow',  \
    CloseWindowStation, <.hWinSta>,  'CloseWindowStation',  \
    CopyAcceleratorTableA, <.hAccelSrc, .lpAccelDst, .cAccelEntries>,  'CopyAcceleratorTableA',  \
    CopyAcceleratorTableW, <.hAccelSrc, .lpAccelDst, .cAccelEntries>,  'CopyAcceleratorTableW',  \
    CopyIcon, <.hIcon>,  'CopyIcon',  \
    CopyImage, <.handle, .un1, .n1, .n2, .un2>,  'CopyImage',  \
    CopyRect, <.lpDestRect, .lpSourceRect>,  'CopyRect',  \
    CountClipboardFormats, <VOID>,  'CountClipboardFormats',  \
    CreateAcceleratorTableA, <.lpaccl, .cEntries>,  'CreateAcceleratorTableA',  \
    CreateAcceleratorTableW, <.lpaccl, .cEntries>,  'CreateAcceleratorTableW',  \
    CreateCaret, <.hwnd, .hBitmap, .nWidth, .nHeight>,  'CreateCaret',  \
    CreateCursor, <.hInstance, .nXhotspot, .nYhotspot, .nWidth, .nHeight, .lpANDbitPlane, .lpXORbitPlane>,  'CreateCursor',  \
    CreateDesktopA, <.lpszDesktop, .lpszDevice, .pDevmode, .dwFlags, .dwDesiredAccess, .lpsa>,  'CreateDesktopA',  \
    CreateDesktopW, <.lpszDesktop, .lpszDevice, .pDevmode, .dwFlags, .dwDesiredAccess, .lpsa>,  'CreateDesktopW',  \
    CreateDialogIndirectParamA, <.hInstance, .lpTemplate, .hWndParent, .lpDialogFunc, .dwInitParam>,  'CreateDialogIndirectParamA',  \
    CreateDialogIndirectParamAorW, <NONE>,  'CreateDialogIndirectParamAorW',  \
    CreateDialogIndirectParamW, <.hInstance, .lpTemplate, .hWndParent, .lpDialogFunc, .dwInitParam>,  'CreateDialogIndirectParamW',  \
    CreateDialogParamA, <.hInstance, .lpName, .hWndParent, .lpDialogFunc, .lParamInit>,  'CreateDialogParamA',  \
    CreateDialogParamW, <.hInstance, .lpName, .hWndParent, .lpDialogFunc, .lParamInit>,  'CreateDialogParamW',  \
    CreateIcon, <.hInstance, .nWidth, .nHeight, .nPlanes, .nBitsPixel, .lpANDbits, .lpXORbits>,  'CreateIcon',  \
    CreateIconFromResource, <.presbits, .dwResSize, .fIcon, .dwVer>,  'CreateIconFromResource',  \
    CreateIconFromResourceEx, <.presbits, .dwResSize, .fIcon, .dwVer, .cxDesired, .cyDesired, .Flags>,  'CreateIconFromResourceEx',  \
    CreateIconIndirect, <.piconinfo>,  'CreateIconIndirect',  \
    CreateMDIWindowA, <.lpClassName, .lpWindowName, .dwStyle, .x, .y, .nWidth, .nHeight, .hWndParent, .hInstance, .lParam>,  'CreateMDIWindowA',  \
    CreateMDIWindowW, <.lpClassName, .lpWindowName, .dwStyle, .x, .y, .nWidth, .nHeight, .hWndParent, .hInstance, .lParam>,  'CreateMDIWindowW',  \
    CreateMenu, <VOID>,  'CreateMenu',  \
    CreatePopupMenu, <VOID>,  'CreatePopupMenu',  \
    CreateSystemThreads, <NONE>,  'CreateSystemThreads',  \
    CreateWindowExA, <.dwExStyle, .lpClassName, .lpWindowName, .dwStyle, .x, .y, .nWidth, .nHeight, .hWndParent, .hMenu, .hInstance,  \
        .lpParam>,  'CreateWindowExA',  \
    CreateWindowExW, <.dwExStyle, .lpClassName, .lpWindowName, .dwStyle, .x, .y, .nWidth, .nHeight, .hWndParent, .hMenu, .hInstance,  \
        .lpParam>,  'CreateWindowExW',  \
    CreateWindowStationA, <.lpwinsta, .dwReserved, .dwDesiredAccess, .lpsa>,  'CreateWindowStationA',  \
    CreateWindowStationW, <.lpwinsta, .dwReserved, .dwDesiredAccess, .lpsa>,  'CreateWindowStationW',  \
    CsrBroadcastSystemMessageExW, <NONE>,  'CsrBroadcastSystemMessageExW',  \
    CtxInitUser32, <NONE>,  'CtxInitUser32',  \
    DdeAbandonTransaction, <.idInst, .hConv, .idTransaction>,  'DdeAbandonTransaction',  \
    DdeAccessData, <.hData, .pcbDataSize>,  'DdeAccessData',  \
    DdeAddData, <.hData, .pSrc, .cb, .cbOff>,  'DdeAddData',  \
    DdeClientTransaction, <.pData, .cbData, .hConv, .hszItem, .wFmt, .wType, .dwTimeout, .pdwResult>,  'DdeClientTransaction',  \
    DdeCmpStringHandles, <.hsz1, .hsz2>,  'DdeCmpStringHandles',  \
    DdeConnect, <.idInst, .hszService, .hszTopic, .pCC>,  'DdeConnect',  \
    DdeConnectList, <.idInst, .hszService, .hszTopic, .hConvList, .pCC>,  'DdeConnectList',  \
    DdeCreateDataHandle, <.idInst, .pSrc, .cb, .cbOff, .hszItem, .wFmt, .afCmd>,  'DdeCreateDataHandle',  \
    DdeCreateStringHandleA, <.idInst, .psz, .iCodePage>,  'DdeCreateStringHandleA',  \
    DdeCreateStringHandleW, <.idInst, .psz, .iCodePage>,  'DdeCreateStringHandleW',  \
    DdeDisconnect, <.hConv>,  'DdeDisconnect',  \
    DdeDisconnectList, <.hConvList>,  'DdeDisconnectList',  \
    DdeEnableCallback, <.idInst, .hConv, .wCmd>,  'DdeEnableCallback',  \
    DdeFreeDataHandle, <.hData>,  'DdeFreeDataHandle',  \
    DdeFreeStringHandle, <.idInst, .hsz>,  'DdeFreeStringHandle',  \
    DdeGetData, <.hData, .pDst, .cbMax, .cbOff>,  'DdeGetData',  \
    DdeGetLastError, <.idInst>,  'DdeGetLastError',  \
    DdeGetQualityOfService, <NONE>,  'DdeGetQualityOfService',  \
    DdeImpersonateClient, <.hConv>,  'DdeImpersonateClient',  \
    DdeInitializeA, <.pidInst, .pfnCallback, .afCmd, .ulRes>,  'DdeInitializeA',  \
    DdeInitializeW, <.pidInst, .pfnCallback, .afCmd, .ulRes>,  'DdeInitializeW',  \
    DdeKeepStringHandle, <.idInst, .hsz>,  'DdeKeepStringHandle',  \
    DdeNameService, <.idInst, .hsz1, .hsz2, .afCmd>,  'DdeNameService',  \
    DdePostAdvise, <.idInst, .hszTopic, .hszItem>,  'DdePostAdvise',  \
    DdeQueryConvInfo, <.hConv, .idTransaction, .pConvInfo>,  'DdeQueryConvInfo',  \
    DdeQueryNextServer, <.hConvList, .hConvPrev>,  'DdeQueryNextServer',  \
    DdeQueryStringA, <.idInst, .hsz, .psz, .cchMax, .iCodePage>,  'DdeQueryStringA',  \
    DdeQueryStringW, <.idInst, .hsz, .psz, .cchMax, .iCodePage>,  'DdeQueryStringW',  \
    DdeReconnect, <.hConv>,  'DdeReconnect',  \
    DdeSetQualityOfService, <.hWndClient, .pqosNew, .pqosPrev>,  'DdeSetQualityOfService',  \
    DdeSetUserHandle, <.hConv, .id, .hUser>,  'DdeSetUserHandle',  \
    DdeUnaccessData, <.hData>,  'DdeUnaccessData',  \
    DdeUninitialize, <.idInst>,  'DdeUninitialize',  \
    DefDlgProcA, <.hDlg, .wMsg, .wParam, .lParam>,  'DefDlgProcA',  \
    DefDlgProcW, <.hDlg, .wMsg, .wParam, .lParam>,  'DefDlgProcW',  \
    DefFrameProcA, <.hwnd, .hWndMDIClient, .wMsg, .wParam, .lParam>,  'DefFrameProcA',  \
    DefFrameProcW, <.hwnd, .hWndMDIClient, .wMsg, .wParam, .lParam>,  'DefFrameProcW',  \
    DefMDIChildProcA, <.hwnd, .wMsg, .wParam, .lParam>,  'DefMDIChildProcA',  \
    DefMDIChildProcW, <.hwnd, .wMsg, .wParam, .lParam>,  'DefMDIChildProcW',  \
    DefRawInputProc, <NONE>,  'DefRawInputProc',  \
    DefWindowProcA, <.hwnd, .wMsg, .wParam, .lParam>,  'DefWindowProcA',  \
    DefWindowProcW, <.hwnd, .wMsg, .wParam, .lParam>,  'DefWindowProcW',  \
    DeferWindowPos, <.hWinPosInfo, .hwnd, .hWndInsertAfter, .x, .y, .cx, .cy, .wFlags>,  'DeferWindowPos',  \
    DeleteMenu, <.hMenu, .nPosition, .wFlags>,  'DeleteMenu',  \
    DeregisterShellHookWindow, <NONE>,  'DeregisterShellHookWindow',  \
    DestroyAcceleratorTable, <.haccel>,  'DestroyAcceleratorTable',  \
    DestroyCaret, <VOID>,  'DestroyCaret',  \
    DestroyCursor, <.hCursor>,  'DestroyCursor',  \
    DestroyIcon, <.hIcon>,  'DestroyIcon',  \
    DestroyMenu, <.hMenu>,  'DestroyMenu',  \
    DestroyReasons, <NONE>,  'DestroyReasons',  \
    DestroyWindow, <.hwnd>,  'DestroyWindow',  \
    DeviceEventWorker, <NONE>,  'DeviceEventWorker',  \
    DialogBoxIndirectParamA, <.hInstance, .hDialogTemplate, .hWndParent, .lpDialogFunc, .dwInitParam>,  'DialogBoxIndirectParamA',  \
    DialogBoxIndirectParamAorW, <NONE>,  'DialogBoxIndirectParamAorW',  \
    DialogBoxIndirectParamW, <.hInstance, .hDialogTemplate, .hWndParent, .lpDialogFunc, .dwInitParam>,  'DialogBoxIndirectParamW',  \
    DialogBoxParamA, <.hInstance, .lpTemplateName, .hWndParent, .lpDialogFunc, .dwInitParam>,  'DialogBoxParamA',  \
    DialogBoxParamW, <.hInstance, .lpTemplateName, .hWndParent, .lpDialogFunc, .dwInitParam>,  'DialogBoxParamW',  \
    DisableProcessWindowsGhosting, <NONE>,  'DisableProcessWindowsGhosting',  \
    DispatchMessageA, <.lpMsg>,  'DispatchMessageA',  \
    DispatchMessageW, <.lpMsg>,  'DispatchMessageW',  \
    DisplayExitWindowsWarnings, <NONE>,  'DisplayExitWindowsWarnings',  \
    DlgDirListA, <.hDlg, .lpPathSpec, .nIDListBox, .nIDStaticPath, .wFileType>,  'DlgDirListA',  \
    DlgDirListComboBoxA, <.hDlg, .lpPathSpec, .nIDComboBox, .nIDStaticPath, .wFileType>,  'DlgDirListComboBoxA',  \
    DlgDirListComboBoxW, <.hDlg, .lpPathSpec, .nIDComboBox, .nIDStaticPath, .wFileType>,  'DlgDirListComboBoxW',  \
    DlgDirListW, <.hDlg, .lpPathSpec, .nIDListBox, .nIDStaticPath, .wFileType>,  'DlgDirListW',  \
    DlgDirSelectComboBoxExA, <.hWndDlg, .lpszPath, .cbPath, .idComboBox>,  'DlgDirSelectComboBoxExA',  \
    DlgDirSelectComboBoxExW, <.hWndDlg, .lpszPath, .cbPath, .idComboBox>,  'DlgDirSelectComboBoxExW',  \
    DlgDirSelectExA, <.hWndDlg, .lpszPath, .cbPath, .idListBox>,  'DlgDirSelectExA',  \
    DlgDirSelectExW, <.hWndDlg, .lpszPath, .cbPath, .idListBox>,  'DlgDirSelectExW',  \
    DragDetect, <.hWnd, .pt>,  'DragDetect',  \
    DragObject, <.hWnd1, .hWnd2, .un, .dw, .hCursor>,  'DragObject',  \
    DrawAnimatedRects, <.hwnd, .idAni, .lprcFrom, .lprcTo>,  'DrawAnimatedRects',  \
    DrawCaption, <.hWnd, .hDC, .pcRect, .uDCFlags>,  'DrawCaption',  \
    DrawCaptionTempA, <NONE>,  'DrawCaptionTempA',  \
    DrawCaptionTempW, <NONE>,  'DrawCaptionTempW',  \
    DrawEdge, <.hdc, .qrc, .edge, .grfFlags>,  'DrawEdge',  \
    DrawFocusRect, <.hdc, .lpRect>,  'DrawFocusRect',  \
    DrawFrame, <NONE>,  'DrawFrame',  \
    DrawFrameControl, <.hDC, .lpRect, .uFrameType, .uFrameState>,  'DrawFrameControl',  \
    DrawIcon, <.hdc, .x, .y, .hIcon>,  'DrawIcon',  \
    DrawIconEx, <.hdc, .xLeft, .yTop, .hIcon, .cxWidth, .cyWidth, .istepIfAniCur, .hbrFlickerFreeDraw, .diFlags>,  'DrawIconEx',  \
    DrawMenuBar, <.hwnd>,  'DrawMenuBar',  \
    DrawMenuBarTemp, <NONE>,  'DrawMenuBarTemp',  \
    DrawStateA, <.hDC, .hBrush, .lpDrawStateProc, .lParam, .wParam, .n1, .n2, .n3, .n4, .un>,  'DrawStateA',  \
    DrawStateW, <.hDC, .hBrush, .lpDrawStateProc, .lParam, .wParam, .n1, .n2, .n3, .n4, .un>,  'DrawStateW',  \
    DrawTextA, <.hdc, .lpStr, .nCount, .lpRect, .wFormat>,  'DrawTextA',  \
    DrawTextExA, <.hDC, .lpsz, .n, .lpRect, .un, .lpDrawTextParams>,  'DrawTextExA',  \
    DrawTextExW, <.hDC, .lpsz, .n, .lpRect, .un, .lpDrawTextParams>,  'DrawTextExW',  \
    DrawTextW, <.hdc, .lpStr, .nCount, .lpRect, .wFormat>,  'DrawTextW',  \
    EditWndProc, <NONE>,  'EditWndProc',  \
    EmptyClipboard, <VOID>,  'EmptyClipboard',  \
    EnableMenuItem, <.hMenu, .wIDEnableItem, .wEnable>,  'EnableMenuItem',  \
    EnableScrollBar, <.hwnd, .wSBflags, .wArrows>,  'EnableScrollBar',  \
    EnableWindow, <.hwnd, .fBoolean>,  'EnableWindow',  \
    EndDeferWindowPos, <.hWinPosInfo>,  'EndDeferWindowPos',  \
    EndDialog, <.hDlg, .nResult>,  'EndDialog',  \
    EndMenu, <VOID>,  'EndMenu',  \
    EndPaint, <.hwnd, .lpPaint>,  'EndPaint',  \
    EndTask, <NONE>,  'EndTask',  \
    EnterReaderModeHelper, <NONE>,  'EnterReaderModeHelper',  \
    EnumChildWindows, <.hWndParent, .lpEnumFunc, .lParam>,  'EnumChildWindows',  \
    EnumClipboardFormats, <.wFormat>,  'EnumClipboardFormats',  \
    EnumDesktopWindows, <.hDesktop, .lpfn, .lParam>,  'EnumDesktopWindows',  \
    EnumDesktopsA, <.hwinsta, .lpEnumFunc, .lParam>,  'EnumDesktopsA',  \
    EnumDesktopsW, <.hwinsta, .lpEnumFunc, .lParam>,  'EnumDesktopsW',  \
    EnumDisplayDevicesA, <.lpDevice, .iDevNum, .lpDisplayDevice, .dwFlags>,  'EnumDisplayDevicesA',  \
    EnumDisplayDevicesW, <.lpDevice, .iDevNum, .lpDisplayDevice, .dwFlags>,  'EnumDisplayDevicesW',  \
    EnumDisplayMonitors, <.hdc, .lprcClip, .lpfnEnum, .dwData>,  'EnumDisplayMonitors',  \
    EnumDisplaySettingsA, <.lpszDeviceName, .iModeNum, .lpDevMode>,  'EnumDisplaySettingsA',  \
    EnumDisplaySettingsExA, <.lpszDeviceName, .iModeNum, .lpDevMode, .dwFlags>,  'EnumDisplaySettingsExA',  \
    EnumDisplaySettingsExW, <.lpszDeviceName, .iModeNum, .lpDevMode, .dwFlags>,  'EnumDisplaySettingsExW',  \
    EnumDisplaySettingsW, <.lpszDeviceName, .iModeNum, .lpDevMode>,  'EnumDisplaySettingsW',  \
    EnumPropsA, <.hWnd, .lpEnumFunc>,  'EnumPropsA',  \
    EnumPropsExA, <.hWnd, .lpEnumFunc, .lParam>,  'EnumPropsExA',  \
    EnumPropsExW, <.hWnd, .lpEnumFunc, .lParam>,  'EnumPropsExW',  \
    EnumPropsW, <.hWnd, .lpEnumFunc>,  'EnumPropsW',  \
    EnumThreadWindows, <.dwThreadId, .lpfn, .lParam>,  'EnumThreadWindows',  \
    EnumWindowStationsA, <.lpEnumFunc, .lParam>,  'EnumWindowStationsA',  \
    EnumWindowStationsW, <.lpEnumFunc, .lParam>,  'EnumWindowStationsW',  \
    EnumWindows, <.lpEnumFunc, .lParam>,  'EnumWindows',  \
    EqualRect, <.lpRect1, .lpRect2>,  'EqualRect',  \
    ExcludeUpdateRgn, <.hdc, .hwnd>,  'ExcludeUpdateRgn',  \
    ExitWindowsEx, <.uFlags, .dwReserved>,  'ExitWindowsEx',  \
    FillRect, <.hdc, .lpRect, .hBrush>,  'FillRect',  \
    FindWindowA, <.lpClassName, .lpWindowName>,  'FindWindowA',  \
    FindWindowExA, <.hWnd1, .hWnd2, .lpsz1, .lpsz2>,  'FindWindowExA',  \
    FindWindowExW, <.hWnd1, .hWnd2, .lpsz1, .lpsz2>,  'FindWindowExW',  \
    FindWindowW, <.lpClassName, .lpWindowName>,  'FindWindowW',  \
    FlashWindow, <.hwnd, .bInvert>,  'FlashWindow',  \
    FlashWindowEx, <.pfwi>,  'FlashWindowEx',  \
    FrameRect, <.hdc, .lpRect, .hBrush>,  'FrameRect',  \
    FreeDDElParam, <.msg, .lParam>,  'FreeDDElParam',  \
    GetActiveWindow, <VOID>,  'GetActiveWindow',  \
    GetAltTabInfo, <.hwnd, .iItem, .pati, .pszItemText, .cchItemText>,  'GetAltTabInfo',  \
    GetAltTabInfoA, <.hwnd, .iItem, .pati, .pszItemText, .cchItemText>,  'GetAltTabInfoA',  \
    GetAltTabInfoW, <.hwnd, .iItem, .pati, .pszItemText, .cchItemText>,  'GetAltTabInfoW',  \
    GetAncestor, <.hwnd, .gaFlags>,  'GetAncestor',  \
    GetAppCompatFlags, <NONE>,  'GetAppCompatFlags',  \
    GetAppCompatFlags2, <NONE>,  'GetAppCompatFlags2',  \
    GetAsyncKeyState, <.vKey>,  'GetAsyncKeyState',  \
    GetCapture, <VOID>,  'GetCapture',  \
    GetCaretBlinkTime, <VOID>,  'GetCaretBlinkTime',  \
    GetCaretPos, <.lpPoint>,  'GetCaretPos',  \
    GetClassInfoA, <.hInstance, .lpClassName, .lpWndClass>,  'GetClassInfoA',  \
    GetClassInfoExA, <.hinstance, .lpcstr, .lpwndclassexa>,  'GetClassInfoExA',  \
    GetClassInfoExW, <.hinstance, .lpcstr, .lpwndclassexa>,  'GetClassInfoExW',  \
    GetClassInfoW, <.hInstance, .lpClassName, .lpWndClass>,  'GetClassInfoW',  \
    GetClassLongA, <.hwnd, .nIndex>,  'GetClassLongA',  \
    GetClassLongW, <.hwnd, .nIndex>,  'GetClassLongW',  \
    GetClassNameA, <.hwnd, .lpClassName, .nMaxCount>,  'GetClassNameA',  \
    GetClassNameW, <.hwnd, .lpClassName, .nMaxCount>,  'GetClassNameW',  \
    GetClassWord, <.hwnd, .nIndex>,  'GetClassWord',  \
    GetClientRect, <.hwnd, .lpRect>,  'GetClientRect',  \
    GetClipCursor, <.lprc>,  'GetClipCursor',  \
    GetClipboardData, <.wFormat>,  'GetClipboardData',  \
    GetClipboardFormatNameA, <.wFormat, .lpString, .nMaxCount>,  'GetClipboardFormatNameA',  \
    GetClipboardFormatNameW, <.wFormat, .lpString, .nMaxCount>,  'GetClipboardFormatNameW',  \
    GetClipboardOwner, <VOID>,  'GetClipboardOwner',  \
    GetClipboardSequenceNumber, <VOID>,  'GetClipboardSequenceNumber',  \
    GetClipboardViewer, <VOID>,  'GetClipboardViewer',  \
    GetComboBoxInfo, <.hwndCombo, .pcbi>,  'GetComboBoxInfo',  \
    GetCursor, <VOID>,  'GetCursor',  \
    GetCursorFrameInfo, <NONE>,  'GetCursorFrameInfo',  \
    GetCursorInfo, <.pci>,  'GetCursorInfo',  \
    GetCursorPos, <.lpPoint>,  'GetCursorPos',  \
    GetDC, <.hwnd>,  'GetDC',  \
    GetDCEx, <.hwnd, .hrgnclip, .fdwOptions>,  'GetDCEx',  \
    GetDesktopWindow, <VOID>,  'GetDesktopWindow',  \
    GetDialogBaseUnits, <VOID>,  'GetDialogBaseUnits',  \
    GetDlgCtrlID, <.hwnd>,  'GetDlgCtrlID',  \
    GetDlgItem, <.hDlg, .nIDDlgItem>,  'GetDlgItem',  \
    GetDlgItemInt, <.hDlg, .nIDDlgItem, .lpTranslated, .bSigned>,  'GetDlgItemInt',  \
    GetDlgItemTextA, <.hDlg, .nIDDlgItem, .lpString, .nMaxCount>,  'GetDlgItemTextA',  \
    GetDlgItemTextW, <.hDlg, .nIDDlgItem, .lpString, .nMaxCount>,  'GetDlgItemTextW',  \
    GetDoubleClickTime, <VOID>,  'GetDoubleClickTime',  \
    GetFocus, <VOID>,  'GetFocus',  \
    GetForegroundWindow, <VOID>,  'GetForegroundWindow',  \
    GetGUIThreadInfo, <.idThread, .pgui>,  'GetGUIThreadInfo',  \
    GetGuiResources, <.hProcess, .uiFlags>,  'GetGuiResources',  \
    GetIconInfo, <.hIcon, .piconinfo>,  'GetIconInfo',  \
    GetInputDesktop, <NONE>,  'GetInputDesktop',  \
    GetInputState, <VOID>,  'GetInputState',  \
    GetInternalWindowPos, <NONE>,  'GetInternalWindowPos',  \
    GetKBCodePage, <VOID>,  'GetKBCodePage',  \
    GetKeyNameTextA, <.lParam, .lpBuffer, .nSize>,  'GetKeyNameTextA',  \
    GetKeyNameTextW, <.lParam, .lpBuffer, .nSize>,  'GetKeyNameTextW',  \
    GetKeyState, <.nVirtKey>,  'GetKeyState',  \
    GetKeyboardLayout, <.dwLayout>,  'GetKeyboardLayout',  \
    GetKeyboardLayoutList, <.nBuff, .lpList>,  'GetKeyboardLayoutList',  \
    GetKeyboardLayoutNameA, <.pwszKLID>,  'GetKeyboardLayoutNameA',  \
    GetKeyboardLayoutNameW, <.pwszKLID>,  'GetKeyboardLayoutNameW',  \
    GetKeyboardState, <.pbKeyState>,  'GetKeyboardState',  \
    GetKeyboardType, <.nTypeFlag>,  'GetKeyboardType',  \
    GetLastActivePopup, <.hwndOwnder>,  'GetLastActivePopup',  \
    GetLastInputInfo, <.plii>,  'GetLastInputInfo',  \
    GetLayeredWindowAttributes, <NONE>,  'GetLayeredWindowAttributes',  \
    GetListBoxInfo, <.hwnd>,  'GetListBoxInfo',  \
    GetMenu, <.hwnd>,  'GetMenu',  \
    GetMenuBarInfo, <.hwnd, .idObject, .idItem, .pmbi>,  'GetMenuBarInfo',  \
    GetMenuCheckMarkDimensions, <VOID>,  'GetMenuCheckMarkDimensions',  \
    GetMenuContextHelpId, <.hMenu>,  'GetMenuContextHelpId',  \
    GetMenuDefaultItem, <.hMenu, .fByPos, .gmdiFlags>,  'GetMenuDefaultItem',  \
    GetMenuInfo, <.hmenu, .LPMENUINFO>,  'GetMenuInfo',  \
    GetMenuItemCount, <.hMenu>,  'GetMenuItemCount',  \
    GetMenuItemID, <.hMenu, .nPos>,  'GetMenuItemID',  \
    GetMenuItemInfoA, <.hMenu, .un, .fBoolean, .lpMenuItemInfo>,  'GetMenuItemInfoA',  \
    GetMenuItemInfoW, <.hMenu, .un, .fBoolean, .lpMenuItemInfo>,  'GetMenuItemInfoW',  \
    GetMenuItemRect, <.hWnd, .hMenu, .uItem, .lprcItem>,  'GetMenuItemRect',  \
    GetMenuState, <.hMenu, .wID, .wFlags>,  'GetMenuState',  \
    GetMenuStringA, <.hMenu, .wIDItem, .lpString, .nMaxCount, .wFlags>,  'GetMenuStringA',  \
    GetMenuStringW, <.hMenu, .wIDItem, .lpString, .nMaxCount, .wFlags>,  'GetMenuStringW',  \
    GetMessageA, <.lpMsg, .hwnd, .wMsgFilterMin, .wMsgFilterMax>,  'GetMessageA',  \
    GetMessageExtraInfo, <VOID>,  'GetMessageExtraInfo',  \
    GetMessagePos, <VOID>,  'GetMessagePos',  \
    GetMessageTime, <VOID>,  'GetMessageTime',  \
    GetMessageW, <.lpMsg, .hwnd, .wMsgFilterMin, .wMsgFilterMax>,  'GetMessageW',  \
    GetMonitorInfoA, <.hMonitor, .lpmi>,  'GetMonitorInfoA',  \
    GetMonitorInfoW, <.hMonitor, .lpmi>,  'GetMonitorInfoW',  \
    GetMouseMovePointsEx, <.cbSize, .lppt, .lpptBuf, .nBufPoints, .resolution>,  'GetMouseMovePointsEx',  \
    GetNextDlgGroupItem, <.hDlg, .hCtl, .bPrevious>,  'GetNextDlgGroupItem',  \
    GetNextDlgTabItem, <.hDlg, .hCtl, .bPrevious>,  'GetNextDlgTabItem',  \
    GetOpenClipboardWindow, <VOID>,  'GetOpenClipboardWindow',  \
    GetParent, <.hwnd>,  'GetParent',  \
    GetPriorityClipboardFormat, <.lpPriorityList, .nCount>,  'GetPriorityClipboardFormat',  \
    GetProcessDefaultLayout, <.pdwDefaultLayout>,  'GetProcessDefaultLayout',  \
    GetProcessWindowStation, <VOID>,  'GetProcessWindowStation',  \
    GetProgmanWindow, <NONE>,  'GetProgmanWindow',  \
    GetPropA, <.hwnd, .lpString>,  'GetPropA',  \
    GetPropW, <.hwnd, .lpString>,  'GetPropW',  \
    GetQueueStatus, <.fuFlags>,  'GetQueueStatus',  \
    GetRawInputBuffer, <NONE>,  'GetRawInputBuffer',  \
    GetRawInputData, <NONE>,  'GetRawInputData',  \
    GetRawInputDeviceInfoA, <NONE>,  'GetRawInputDeviceInfoA',  \
    GetRawInputDeviceInfoW, <NONE>,  'GetRawInputDeviceInfoW',  \
    GetRawInputDeviceList, <NONE>,  'GetRawInputDeviceList',  \
    GetReasonTitleFromReasonCode, <NONE>,  'GetReasonTitleFromReasonCode',  \
    GetRegisteredRawInputDevices, <NONE>,  'GetRegisteredRawInputDevices',  \
    GetScrollBarInfo, <.hwnd, .idObject, .psbi>,  'GetScrollBarInfo',  \
    GetScrollInfo, <.hWnd, .n, .lpScrollInfo>,  'GetScrollInfo',  \
    GetScrollPos, <.hwnd, .nBar>,  'GetScrollPos',  \
    GetScrollRange, <.hwnd, .nBar, .lpMinPos, .lpMaxPos>,  'GetScrollRange',  \
    GetShellWindow, <NONE>,  'GetShellWindow',  \
    GetSubMenu, <.hMenu, .nPos>,  'GetSubMenu',  \
    GetSysColor, <.nSysColor>,  'GetSysColor',  \
    GetSysColorBrush, <.nSysColor>,  'GetSysColorBrush',  \
    GetSystemMenu, <.hwnd, .fBoolean>,  'GetSystemMenu',  \
    GetSystemMetrics, <.nIndex>,  'GetSystemMetrics',  \
    GetTabbedTextExtentA, <.hdc, .lpString, .nCount, .nTabPositions, .lpnTabStopPositions>,  'GetTabbedTextExtentA',  \
    GetTabbedTextExtentW, <.hdc, .lpString, .nCount, .nTabPositions, .lpnTabStopPositions>,  'GetTabbedTextExtentW',  \
    GetTaskmanWindow, <NONE>,  'GetTaskmanWindow',  \
    GetThreadDesktop, <.dwThread>,  'GetThreadDesktop',  \
    GetTitleBarInfo, <.hwnd, .pti>,  'GetTitleBarInfo',  \
    GetTopWindow, <.hwnd>,  'GetTopWindow',  \
    GetUpdateRect, <.hwnd, .lpRect, .bErase>,  'GetUpdateRect',  \
    GetUpdateRgn, <.hwnd, .hRgn, .fErase>,  'GetUpdateRgn',  \
    GetUserObjectInformationA, <.hObj, .nIndex, .pvInfo, .nLength, .lpnLengthNeeded>,  'GetUserObjectInformationA',  \
    GetUserObjectInformationW, <.hObj, .nIndex, .pvInfo, .nLength, .lpnLengthNeeded>,  'GetUserObjectInformationW',  \
    GetUserObjectSecurity, <.hObj, .pSIRequested, .pSd, .nLength, .lpnLengthNeeded>,  'GetUserObjectSecurity',  \
    GetWinStationInfo, <NONE>,  'GetWinStationInfo',  \
    GetWindow, <.hwnd, .wCmd>,  'GetWindow',  \
    GetWindowContextHelpId, <.hWnd>,  'GetWindowContextHelpId',  \
    GetWindowDC, <.hwnd>,  'GetWindowDC',  \
    GetWindowInfo, <.hwnd, .pwi>,  'GetWindowInfo',  \
    GetWindowLongA, <.hwnd, .nIndex>,  'GetWindowLongA',  \
    GetWindowLongW, <.hwnd, .nIndex>,  'GetWindowLongW',  \
    GetWindowModuleFileName, <.hwnd, .pszFileName, .cchFileNameMax>,  'GetWindowModuleFileName',  \
    GetWindowModuleFileNameA, <.hwnd, .pszFileName, .cchFileNameMax>,  'GetWindowModuleFileNameA',  \
    GetWindowModuleFileNameW, <.hwnd, .pszFileName, .cchFileNameMax>,  'GetWindowModuleFileNameW',  \
    GetWindowPlacement, <.hwnd, .lpwndpl>,  'GetWindowPlacement',  \
    GetWindowRect, <.hwnd, .lpRect>,  'GetWindowRect',  \
    GetWindowRgn, <.hWnd, .hRgn>,  'GetWindowRgn',  \
    GetWindowRgnBox, <NONE>,  'GetWindowRgnBox',  \
    GetWindowTextA, <.hwnd, .lpString, .cch>,  'GetWindowTextA',  \
    GetWindowTextLengthA, <.hwnd>,  'GetWindowTextLengthA',  \
    GetWindowTextLengthW, <.hwnd>,  'GetWindowTextLengthW',  \
    GetWindowTextW, <.hwnd, .lpString, .cch>,  'GetWindowTextW',  \
    GetWindowThreadProcessId, <.hwnd, .lpdwProcessId>,  'GetWindowThreadProcessId',  \
    GetWindowWord, <.hwnd, .nIndex>,  'GetWindowWord',  \
    GrayStringA, <.hDC, .hBrush, .lpOutputFunc, .lpData, .nCount, .X, .Y, .nWidth, .nHeight>,  'GrayStringA',  \
    GrayStringW, <.hDC, .hBrush, .lpOutputFunc, .lpData, .nCount, .X, .Y, .nWidth, .nHeight>,  'GrayStringW',  \
    HideCaret, <.hwnd>,  'HideCaret',  \
    HiliteMenuItem, <.hwnd, .hMenu, .wIDHiliteItem, .wHilite>,  'HiliteMenuItem',  \
    IMPGetIMEA, <.hwnd, .LPIMEPROA>,  'IMPGetIMEA',  \
    IMPGetIMEW, <.hwnd, .LPIMEPROA>,  'IMPGetIMEW',  \
    IMPQueryIMEA, <.LPIMEPROA>,  'IMPQueryIMEA',  \
    IMPQueryIMEW, <.LPIMEPROA>,  'IMPQueryIMEW',  \
    IMPSetIMEA, <.hwnd, .LPIMEPROA>,  'IMPSetIMEA',  \
    IMPSetIMEW, <.hwnd, .LPIMEPROA>,  'IMPSetIMEW',  \
    ImpersonateDdeClientWindow, <.hWndClient, .hWndServer>,  'ImpersonateDdeClientWindow',  \
    InSendMessage, <VOID>,  'InSendMessage',  \
    InSendMessageEx, <.lpReserved>,  'InSendMessageEx',  \
    InflateRect, <.lpRect, .x, .y>,  'InflateRect',  \
    InitializeLpkHooks, <NONE>,  'InitializeLpkHooks',  \
    InitializeWin32EntryTable, <NONE>,  'InitializeWin32EntryTable',  \
    InsertMenuA, <.hMenu, .nPosition, .wFlags, .wIDNewItem, .lpNewItem>,  'InsertMenuA',  \
    InsertMenuItemA, <.hMenu, .uItem, .bool, .ByRef>,  'InsertMenuItemA',  \
    InsertMenuItemW, <.hMenu, .uItem, .bool, .ByRef>,  'InsertMenuItemW',  \
    InsertMenuW, <.hMenu, .nPosition, .wFlags, .wIDNewItem, .lpNewItem>,  'InsertMenuW',  \
    InternalGetWindowText, <NONE>,  'InternalGetWindowText',  \
    IntersectRect, <.lpDestRect, .lpSrc1Rect, .lpSrc2Rect>,  'IntersectRect',  \
    InvalidateRect, <.hwnd, .lpRect, .fBoolean>,  'InvalidateRect',  \
    InvalidateRgn, <.hwnd, .hRgn, .bErase>,  'InvalidateRgn',  \
    InvertRect, <.hdc, .lpRect>,  'InvertRect',  \
    IsCharAlphaA, <.cChar>,  'IsCharAlphaA',  \
    IsCharAlphaNumericA, <.cChar>,  'IsCharAlphaNumericA',  \
    IsCharAlphaNumericW, <.cChar>,  'IsCharAlphaNumericW',  \
    IsCharAlphaW, <.cChar>,  'IsCharAlphaW',  \
    IsCharLowerA, <.cChar>,  'IsCharLowerA',  \
    IsCharLowerW, <.cChar>,  'IsCharLowerW',  \
    IsCharUpperA, <.cChar>,  'IsCharUpperA',  \
    IsCharUpperW, <.cChar>,  'IsCharUpperW',  \
    IsChild, <.hWndParent, .hwnd>,  'IsChild',  \
    IsClipboardFormatAvailable, <.wFormat>,  'IsClipboardFormatAvailable',  \
    IsDialogMessage, <.hDlg, .lpMsg>,  'IsDialogMessage',  \
    IsDialogMessageA, <.hDlg, .lpMsg>,  'IsDialogMessageA',  \
    IsDialogMessageW, <.hDlg, .lpMsg>,  'IsDialogMessageW',  \
    IsDlgButtonChecked, <.hDlg, .nIDButton>,  'IsDlgButtonChecked',  \
    IsGUIThread, <NONE>,  'IsGUIThread',  \
    IsHungAppWindow, <NONE>,  'IsHungAppWindow',  \
    IsIconic, <.hwnd>,  'IsIconic',  \
    IsMenu, <.hMenu>,  'IsMenu',  \
    IsRectEmpty, <.lpRect>,  'IsRectEmpty',  \
    IsServerSideWindow, <NONE>,  'IsServerSideWindow',  \
    IsWinEventHookInstalled, <NONE>,  'IsWinEventHookInstalled',  \
    IsWindow, <.hwnd>,  'IsWindow',  \
    IsWindowEnabled, <.hwnd>,  'IsWindowEnabled',  \
    IsWindowInDestroy, <NONE>,  'IsWindowInDestroy',  \
    IsWindowUnicode, <.hwnd>,  'IsWindowUnicode',  \
    IsWindowVisible, <.hwnd>,  'IsWindowVisible',  \
    IsZoomed, <.hwnd>,  'IsZoomed',  \
    KillSystemTimer, <NONE>,  'KillSystemTimer',  \
    KillTimer, <.hwnd, .nIDEvent>,  'KillTimer',  \
    LoadAcceleratorsA, <.hInstance, .lpTableName>,  'LoadAcceleratorsA',  \
    LoadAcceleratorsW, <.hInstance, .lpTableName>,  'LoadAcceleratorsW',  \
    LoadBitmapA, <.hInstance, .lpBitmapName>,  'LoadBitmapA',  \
    LoadBitmapW, <.hInstance, .lpBitmapName>,  'LoadBitmapW',  \
    LoadCursorA, <.hInstance, .lpCursorName>,  'LoadCursorA',  \
    LoadCursorFromFileA, <.lpFileName>,  'LoadCursorFromFileA',  \
    LoadCursorFromFileW, <.lpFileName>,  'LoadCursorFromFileW',  \
    LoadCursorW, <.hInstance, .lpCursorName>,  'LoadCursorW',  \
    LoadIconA, <.hInstance, .lpIconName>,  'LoadIconA',  \
    LoadIconW, <.hInstance, .lpIconName>,  'LoadIconW',  \
    LoadImageA, <.hInst, .lpsz, .uType, .n1, .n2, .uFlags>,  'LoadImageA',  \
    LoadImageW, <.hInst, .lpsz, .uType, .n1, .n2, .uFlags>,  'LoadImageW',  \
    LoadKeyboardLayoutA, <.pwszKLID, .flags>,  'LoadKeyboardLayoutA',  \
    LoadKeyboardLayoutEx, <NONE>,  'LoadKeyboardLayoutEx',  \
    LoadKeyboardLayoutW, <.pwszKLID, .flags>,  'LoadKeyboardLayoutW',  \
    LoadLocalFonts, <NONE>,  'LoadLocalFonts',  \
    LoadMenuA, <.hInstance, .lpString>,  'LoadMenuA',  \
    LoadMenuIndirectA, <.lpMenuTemplate>,  'LoadMenuIndirectA',  \
    LoadMenuIndirectW, <.lpMenuTemplate>,  'LoadMenuIndirectW',  \
    LoadMenuW, <.hInstance, .lpString>,  'LoadMenuW',  \
    LoadRemoteFonts, <NONE>,  'LoadRemoteFonts',  \
    LoadStringA, <.hInstance, .wID, .lpBuffer, .nBufferMax>,  'LoadStringA',  \
    LoadStringW, <.hInstance, .wID, .lpBuffer, .nBufferMax>,  'LoadStringW',  \
    LockSetForegroundWindow, <.uLockCode>,  'LockSetForegroundWindow',  \
    LockWindowStation, <NONE>,  'LockWindowStation',  \
    LockWindowUpdate, <.hwndLock>,  'LockWindowUpdate',  \
    LockWorkStation, <VOID>,  'LockWorkStation',  \
    LookupIconIdFromDirectory, <.presbits, .fIcon>,  'LookupIconIdFromDirectory',  \
    LookupIconIdFromDirectoryEx, <.presbits, .fIcon, .cxDesired, .cyDesired, .Flags>,  'LookupIconIdFromDirectoryEx',  \
    MBToWCSEx, <NONE>,  'MBToWCSEx',  \
    MB_GetString, <NONE>,  'MB_GetString',  \
    MapDialogRect, <.hDlg, .lpRect>,  'MapDialogRect',  \
    MapVirtualKeyA, <.wCode, .wMapType>,  'MapVirtualKeyA',  \
    MapVirtualKeyExA, <.uCode, .uMapType, .dwhkl>,  'MapVirtualKeyExA',  \
    MapVirtualKeyExW, <.uCode, .uMapType, .dwhkl>,  'MapVirtualKeyExW',  \
    MapVirtualKeyW, <.wCode, .wMapType>,  'MapVirtualKeyW',  \
    MapWindowPoints, <.hwndFrom, .hwndTo, .lppt, .cPoints>,  'MapWindowPoints',  \
    MenuItemFromPoint, <.hWnd, .hMenu, .ptScreen>,  'MenuItemFromPoint',  \
    MenuWindowProcA, <NONE>,  'MenuWindowProcA',  \
    MenuWindowProcW, <NONE>,  'MenuWindowProcW',  \
    MessageBeep, <.wType>,  'MessageBeep',  \
    MessageBoxA, <.hwnd, .lpText, .lpCaption, .wType>,  'MessageBoxA',  \
    MessageBoxExA, <.hwnd, .lpText, .lpCaption, .wType, .wLanguageId>,  'MessageBoxExA',  \
    MessageBoxExW, <.hwnd, .lpText, .lpCaption, .wType, .wLanguageId>,  'MessageBoxExW',  \
    MessageBoxIndirectA, <.lpMsgBoxParams>,  'MessageBoxIndirectA',  \
    MessageBoxIndirectW, <.lpMsgBoxParams>,  'MessageBoxIndirectW',  \
    MessageBoxTimeoutA, <NONE>,  'MessageBoxTimeoutA',  \
    MessageBoxTimeoutW, <NONE>,  'MessageBoxTimeoutW',  \
    MessageBoxW, <.hwnd, .lpText, .lpCaption, .wType>,  'MessageBoxW',  \
    ModifyMenuA, <.hMenu, .nPosition, .wFlags, .wIDNewItem, .lpString>,  'ModifyMenuA',  \
    ModifyMenuW, <.hMenu, .nPosition, .wFlags, .wIDNewItem, .lpString>,  'ModifyMenuW',  \
    MonitorFromPoint, <.pt, .dwFlags>,  'MonitorFromPoint',  \
    MonitorFromRect, <.lprc, .dwFlags>,  'MonitorFromRect',  \
    MonitorFromWindow, <.hwnd, .dwFlags>,  'MonitorFromWindow',  \
    MoveWindow, <.hwnd, .x, .y, .nWidth, .nHeight, .fBoolean>,  'MoveWindow',  \
    MsgWaitForMultipleObjects, <.nCount, .pHandles, .fWaitAll, .dwMilliseconds, .dwWakeMask>,  'MsgWaitForMultipleObjects',  \
    MsgWaitForMultipleObjectsEx, <.nCount, .pHandles, .dwMilliseconds, .dwWakeMask, .dwFlags>,  'MsgWaitForMultipleObjectsEx',  \
    NotifyWinEvent, <.lEvent, .hwnd, .idObject, .idChild>,  'NotifyWinEvent',  \
    OemKeyScan, <.wOemChar>,  'OemKeyScan',  \
    OemToCharA, <.lpszSrc, .lpszDst>,  'OemToCharA',  \
    OemToCharBuffA, <.lpszSrc, .lpszDst, .cchDstLength>,  'OemToCharBuffA',  \
    OemToCharBuffW, <.lpszSrc, .lpszDst, .cchDstLength>,  'OemToCharBuffW',  \
    OemToCharW, <.lpszSrc, .lpszDst>,  'OemToCharW',  \
    OffsetRect, <.lpRect, .x, .y>,  'OffsetRect',  \
    OpenClipboard, <.hwnd>,  'OpenClipboard',  \
    OpenDesktopA, <.lpszDesktop, .dwFlags, .fInherit, .dwDesiredAccess>,  'OpenDesktopA',  \
    OpenDesktopW, <.lpszDesktop, .dwFlags, .fInherit, .dwDesiredAccess>,  'OpenDesktopW',  \
    OpenIcon, <.hwnd>,  'OpenIcon',  \
    OpenInputDesktop, <.dwFlags, .fInherit, .dwDesiredAccess>,  'OpenInputDesktop',  \
    OpenWindowStationA, <.lpszWinSta, .fInherit, .dwDesiredAccess>,  'OpenWindowStationA',  \
    OpenWindowStationW, <.lpszWinSta, .fInherit, .dwDesiredAccess>,  'OpenWindowStationW',  \
    PackDDElParam, <.msg, .uiLo, .uiHi>,  'PackDDElParam',  \
    PaintDesktop, <.hdc>,  'PaintDesktop',  \
    PaintMenuBar, <NONE>,  'PaintMenuBar',  \
    PeekMessageA, <.lpMsg, .hwnd, .wMsgFilterMin, .wMsgFilterMax, .wRemoveMsg>,  'PeekMessageA',  \
    PeekMessageW, <.lpMsg, .hwnd, .wMsgFilterMin, .wMsgFilterMax, .wRemoveMsg>,  'PeekMessageW',  \
    PostMessageA, <.hwnd, .wMsg, .wParam, .lParam>,  'PostMessageA',  \
    PostMessageW, <.hwnd, .wMsg, .wParam, .lParam>,  'PostMessageW',  \
    PostQuitMessage, <.nExitCode>,  'PostQuitMessage',  \
    PostThreadMessageA, <.idThread, .msg, .wParam, .lParam>,  'PostThreadMessageA',  \
    PostThreadMessageW, <.idThread, .msg, .wParam, .lParam>,  'PostThreadMessageW',  \
    PrintWindow, <.hWnd, .hdcBlt, .nFlags>,  'PrintWindow',  \
    PrivateExtractIconExA, <NONE>,  'PrivateExtractIconExA',  \
    PrivateExtractIconExW, <NONE>,  'PrivateExtractIconExW',  \
    PrivateExtractIconsA, <NONE>,  'PrivateExtractIconsA',  \
    PrivateExtractIconsW, <NONE>,  'PrivateExtractIconsW',  \
    PrivateSetDbgTag, <NONE>,  'PrivateSetDbgTag',  \
    PrivateSetRipFlags, <NONE>,  'PrivateSetRipFlags',  \
    PtInRect, <.lpRect, .x, .y>,  'PtInRect',  \
    QuerySendMessage, <NONE>,  'QuerySendMessage',  \
    QueryUserCounters, <NONE>,  'QueryUserCounters',  \
    RealChildWindowFromPoint, <.hwndParent, .ptParentClientCoords>,  'RealChildWindowFromPoint',  \
    RealGetWindowClass, <.hwnd, .pszType, .cchType>,  'RealGetWindowClass',  \
    RealGetWindowClassA, <.hwnd, .pszType, .cchType>,  'RealGetWindowClassA',  \
    RealGetWindowClassW, <.hwnd, .pszType, .cchType>,  'RealGetWindowClassW',  \
    ReasonCodeNeedsBugID, <NONE>,  'ReasonCodeNeedsBugID',  \
    ReasonCodeNeedsComment, <NONE>,  'ReasonCodeNeedsComment',  \
    RecordShutdownReason, <NONE>,  'RecordShutdownReason',  \
    RedrawWindow, <.hwnd, .lprcUpdate, .hrgnUpdate, .fuRedraw>,  'RedrawWindow',  \
    RegisterClassA, <.Class>,  'RegisterClassA',  \
    RegisterClassExA, <.pcWndClassEx>,  'RegisterClassExA',  \
    RegisterClassExW, <.pcWndClassEx>,  'RegisterClassExW',  \
    RegisterClassW, <.Class>,  'RegisterClassW',  \
    RegisterClipboardFormatA, <.lpString>,  'RegisterClipboardFormatA',  \
    RegisterClipboardFormatW, <.lpString>,  'RegisterClipboardFormatW',  \
    RegisterDeviceNotificationA, <.hRecipient, .NotificationFilter, .Flags>,  'RegisterDeviceNotificationA',  \
    RegisterDeviceNotificationW, <.hRecipient, .NotificationFilter, .Flags>,  'RegisterDeviceNotificationW',  \
    RegisterHotKey, <.hwnd, .id, .fsModifiers, .vk>,  'RegisterHotKey',  \
    RegisterLogonProcess, <NONE>,  'RegisterLogonProcess',  \
    RegisterMessagePumpHook, <NONE>,  'RegisterMessagePumpHook',  \
    RegisterRawInputDevices, <NONE>,  'RegisterRawInputDevices',  \
    RegisterServicesProcess, <NONE>,  'RegisterServicesProcess',  \
    RegisterShellHookWindow, <NONE>,  'RegisterShellHookWindow',  \
    RegisterSystemThread, <NONE>,  'RegisterSystemThread',  \
    RegisterTasklist, <NONE>,  'RegisterTasklist',  \
    RegisterUserApiHook, <NONE>,  'RegisterUserApiHook',  \
    RegisterWindowMessageA, <.lpString>,  'RegisterWindowMessageA',  \
    RegisterWindowMessageW, <.lpString>,  'RegisterWindowMessageW',  \
    ReleaseCapture, <VOID>,  'ReleaseCapture',  \
    ReleaseDC, <.hwnd, .hdc>,  'ReleaseDC',  \
    RemoveMenu, <.hMenu, .nPosition, .wFlags>,  'RemoveMenu',  \
    RemovePropA, <.hwnd, .lpString>,  'RemovePropA',  \
    RemovePropW, <.hwnd, .lpString>,  'RemovePropW',  \
    ReplyMessage, <.lReply>,  'ReplyMessage',  \
    ResolveDesktopForWOW, <NONE>,  'ResolveDesktopForWOW',  \
    ReuseDDElParam, <.lParam, .msgIn, .msgOut, .uiLo, .uiHi>,  'ReuseDDElParam',  \
    ScreenToClient, <.hwnd, .lpPoint>,  'ScreenToClient',  \
    ScrollChildren, <NONE>,  'ScrollChildren',  \
    ScrollDC, <.hdc, .dx, .dy, .lprcScroll, .lprcClip, .hrgnUpdate, .lprcUpdate>,  'ScrollDC',  \
    ScrollWindow, <.hWnd, .XAmount, .YAmount, .lpRect, .lpClipRect>,  'ScrollWindow',  \
    ScrollWindowEx, <.hwnd, .dx, .dy, .lprcScroll, .lprcClip, .hrgnUpdate, .lprcUpdate, .fuScroll>,  'ScrollWindowEx',  \
    SendDlgItemMessageA, <.hDlg, .nIDDlgItem, .wMsg, .wParam, .lParam>,  'SendDlgItemMessageA',  \
    SendDlgItemMessageW, <.hDlg, .nIDDlgItem, .wMsg, .wParam, .lParam>,  'SendDlgItemMessageW',  \
    SendIMEMessageExA, <.hwnd, .lparam>,  'SendIMEMessageExA',  \
    SendIMEMessageExW, <.hwnd, .lparam>,  'SendIMEMessageExW',  \
    SendInput, <.cInputs, .pInputs, .cbSize>,  'SendInput',  \
    SendMessageA, <.hwnd, .wMsg, .wParam, .lParam>,  'SendMessageA',  \
    SendMessageCallbackA, <.hwnd, .wMsg, .wParam, .lParam, .lpResultCallBack, .dwData>,  'SendMessageCallbackA',  \
    SendMessageCallbackW, <.hwnd, .wMsg, .wParam, .lParam, .lpResultCallBack, .dwData>,  'SendMessageCallbackW',  \
    SendMessageTimeoutA, <.hwnd, .msg, .wParam, .lParam, .fuFlags, .uTimeout, .lpdwResult>,  'SendMessageTimeoutA',  \
    SendMessageTimeoutW, <.hwnd, .msg, .wParam, .lParam, .fuFlags, .uTimeout, .lpdwResult>,  'SendMessageTimeoutW',  \
    SendMessageW, <.hwnd, .wMsg, .wParam, .lParam>,  'SendMessageW',  \
    SendNotifyMessageA, <.hwnd, .msg, .wParam, .lParam>,  'SendNotifyMessageA',  \
    SendNotifyMessageW, <.hwnd, .msg, .wParam, .lParam>,  'SendNotifyMessageW',  \
    SetActiveWindow, <.hwnd>,  'SetActiveWindow',  \
    SetCapture, <.hwnd>,  'SetCapture',  \
    SetCaretBlinkTime, <.wMSeconds>,  'SetCaretBlinkTime',  \
    SetCaretPos, <.x, .y>,  'SetCaretPos',  \
    SetClassLongA, <.hwnd, .nIndex, .dwNewLong>,  'SetClassLongA',  \
    SetClassLongW, <.hwnd, .nIndex, .dwNewLong>,  'SetClassLongW',  \
    SetClassWord, <.hwnd, .nIndex, .wNewWord>,  'SetClassWord',  \
    SetClipboardData, <.uFormat, .hMem>,  'SetClipboardData',  \
    SetClipboardViewer, <.hwnd>,  'SetClipboardViewer',  \
    SetConsoleReserveKeys, <NONE>,  'SetConsoleReserveKeys',  \
    SetCursor, <.hCursor>,  'SetCursor',  \
    SetCursorContents, <NONE>,  'SetCursorContents',  \
    SetCursorPos, <.x, .y>,  'SetCursorPos',  \
    SetDebugErrorLevel, <.dwLevel>,  'SetDebugErrorLevel',  \
    SetDeskWallpaper, <NONE>,  'SetDeskWallpaper',  \
    SetDlgItemInt, <.hDlg, .nIDDlgItem, .wValue, .bSigned>,  'SetDlgItemInt',  \
    SetDlgItemTextA, <.hDlg, .nIDDlgItem, .lpString>,  'SetDlgItemTextA',  \
    SetDlgItemTextW, <.hDlg, .nIDDlgItem, .lpString>,  'SetDlgItemTextW',  \
    SetDoubleClickTime, <.wCount>,  'SetDoubleClickTime',  \
    SetFocus, <.hwnd>,  'SetFocus',  \
    SetForegroundWindow, <.hwnd>,  'SetForegroundWindow',  \
    SetInternalWindowPos, <NONE>,  'SetInternalWindowPos',  \
    SetKeyboardState, <.lppbKeyState>,  'SetKeyboardState',  \
    SetLastErrorEx, <.dwErrCode, .dwType>,  'SetLastErrorEx',  \
    SetLayeredWindowAttributes, <.hwnd, .crKey, .bAlpha, .dwFlags>,  'SetLayeredWindowAttributes',  \
    SetLogonNotifyWindow, <NONE>,  'SetLogonNotifyWindow',  \
    SetMenu, <.hwnd, .hMenu>,  'SetMenu',  \
    SetMenuContextHelpId, <.hMenu, .dw>,  'SetMenuContextHelpId',  \
    SetMenuDefaultItem, <.hMenu, .uItem, .fByPos>,  'SetMenuDefaultItem',  \
    SetMenuInfo, <.hmenu, .LPCMENUINFO>,  'SetMenuInfo',  \
    SetMenuItemBitmaps, <.hMenu, .nPosition, .wFlags, .hBitmapUnchecked, .hBitmapChecked>,  'SetMenuItemBitmaps',  \
    SetMenuItemInfoA, <.hMenu, .un, .fBoolean, .lpcMenuItemInfo>,  'SetMenuItemInfoA',  \
    SetMenuItemInfoW, <.hMenu, .un, .fBoolean, .lpcMenuItemInfo>,  'SetMenuItemInfoW',  \
    SetMessageExtraInfo, <.lParam>,  'SetMessageExtraInfo',  \
    SetMessageQueue, <.cMessagesMax>,  'SetMessageQueue',  \
    SetParent, <.hWndChild, .hWndNewParent>,  'SetParent',  \
    SetProcessDefaultLayout, <.dwDefaultLayout>,  'SetProcessDefaultLayout',  \
    SetProcessWindowStation, <.hWinSta>,  'SetProcessWindowStation',  \
    SetProgmanWindow, <NONE>,  'SetProgmanWindow',  \
    SetPropA, <.hwnd, .lpString, .hData>,  'SetPropA',  \
    SetPropW, <.hwnd, .lpString, .hData>,  'SetPropW',  \
    SetRect, <.lpRect, .X1, .Y1, .X2, .Y2>,  'SetRect',  \
    SetRectEmpty, <.lpRect>,  'SetRectEmpty',  \
    SetScrollInfo, <.hWnd, .n, .lpcScrollInfo, .bool>,  'SetScrollInfo',  \
    SetScrollPos, <.hwnd, .nBar, .nPos, .fBoolean>,  'SetScrollPos',  \
    SetScrollRange, <.hwnd, .nBar, .nMinPos, .nMaxPos, .bRedraw>,  'SetScrollRange',  \
    SetShellWindow, <NONE>,  'SetShellWindow',  \
    SetShellWindowEx, <NONE>,  'SetShellWindowEx',  \
    SetSysColors, <.nChanges, .lpSysColor, .lpColorValues>,  'SetSysColors',  \
    SetSysColorsTemp, <NONE>,  'SetSysColorsTemp',  \
    SetSystemCursor, <.hcur, .id>,  'SetSystemCursor',  \
    SetSystemMenu, <NONE>,  'SetSystemMenu',  \
    SetSystemTimer, <NONE>,  'SetSystemTimer',  \
    SetTaskmanWindow, <NONE>,  'SetTaskmanWindow',  \
    SetThreadDesktop, <.hDesktop>,  'SetThreadDesktop',  \
    SetTimer, <.hWnd, .nIDEvent, .uElapse, .lpTimerFunc>,  'SetTimer',  \
    SetUserObjectInformationA, <.hObj, .nIndex, .pvInfo, .nLength>,  'SetUserObjectInformationA',  \
    SetUserObjectInformationW, <.hObj, .nIndex, .pvInfo, .nLength>,  'SetUserObjectInformationW',  \
    SetUserObjectSecurity, <.hObj, .pSIRequested, .pSd>,  'SetUserObjectSecurity',  \
    SetWinEventHook, <.eventMin, .eventMax, .hmodWinEventProc, .pfnWinEventProc, .idProcess, .idThread, .dwFlags>,  'SetWinEventHook',  \
    SetWindowContextHelpId, <.hWnd, .dw>,  'SetWindowContextHelpId',  \
    SetWindowLongA, <.hwnd, .nIndex, .dwNewLong>,  'SetWindowLongA',  \
    SetWindowLongW, <.hwnd, .nIndex, .dwNewLong>,  'SetWindowLongW',  \
    SetWindowPlacement, <.hwnd, .lpwndpl>,  'SetWindowPlacement',  \
    SetWindowPos, <.hwnd, .hWndInsertAfter, .x, .y, .cx, .cy, .wFlags>,  'SetWindowPos',  \
    SetWindowRgn, <.hWnd, .hRgn, .bRedraw>,  'SetWindowRgn',  \
    SetWindowStationUser, <NONE>,  'SetWindowStationUser',  \
    SetWindowTextA, <.hwnd, .lpString>,  'SetWindowTextA',  \
    SetWindowTextW, <.hwnd, .lpString>,  'SetWindowTextW',  \
    SetWindowWord, <.hwnd, .nIndex, .wNewWord>,  'SetWindowWord',  \
    SetWindowsHookA, <.nFilterType, .pfnFilterProc>,  'SetWindowsHookA',  \
    SetWindowsHookExA, <.idHook, .lpfn, .hmod, .dwThreadId>,  'SetWindowsHookExA',  \
    SetWindowsHookExW, <.idHook, .lpfn, .hmod, .dwThreadId>,  'SetWindowsHookExW',  \
    SetWindowsHookW, <.nFilterType, .pfnFilterProc>,  'SetWindowsHookW',  \
    ShowCaret, <.hwnd>,  'ShowCaret',  \
    ShowCursor, <.bShow>,  'ShowCursor',  \
    ShowOwnedPopups, <.hwnd, .fBoolean>,  'ShowOwnedPopups',  \
    ShowScrollBar, <.hwnd, .wBar, .bShow>,  'ShowScrollBar',  \
    ShowStartGlass, <NONE>,  'ShowStartGlass',  \
    ShowWindow, <.hwnd, .nCmdShow>,  'ShowWindow',  \
    ShowWindowAsync, <.hWnd, .nCmdShow>,  'ShowWindowAsync',  \
    SoftModalMessageBox, <NONE>,  'SoftModalMessageBox',  \
    SubtractRect, <.lprcDst, .lprcSrc1, .lprcSrc2>,  'SubtractRect',  \
    SwapMouseButton, <.bSwap>,  'SwapMouseButton',  \
    SwitchDesktop, <.hDesktop>,  'SwitchDesktop',  \
    SwitchToThisWindow, <NONE>,  'SwitchToThisWindow',  \
    SystemParametersInfoA, <.uAction, .uParam, .ByRef, .fuWinIni>,  'SystemParametersInfoA',  \
    SystemParametersInfoW, <.uAction, .uParam, .ByRef, .fuWinIni>,  'SystemParametersInfoW',  \
    TabbedTextOutA, <.hdc, .x, .y, .lpString, .nCount, .nTabPositions, .lpnTabStopPositions, .nTabOrigin>,  'TabbedTextOutA',  \
    TabbedTextOutW, <.hdc, .x, .y, .lpString, .nCount, .nTabPositions, .lpnTabStopPositions, .nTabOrigin>,  'TabbedTextOutW',  \
    TileChildWindows, <NONE>,  'TileChildWindows',  \
    TileWindows, <.hwndParent, .wHow, .lpRect, .cKids, .lpKids>,  'TileWindows',  \
    ToAscii, <.uVirtKey, .uScanCode, .lpbKeyState, .lpwTransKey, .fuState>,  'ToAscii',  \
    ToAsciiEx, <.uVirtKey, .uScanCode, .lpKeyState, .lpChar, .uFlags, .dwhkl>,  'ToAsciiEx',  \
    ToUnicode, <.wVirtKey, .wScanCode, .lpKeyState, .pwszBuff, .cchBuff, .wFlags>,  'ToUnicode',  \
    ToUnicodeEx, <.wVirtKey, .wScanCode, .lpKeyState, .pwszBuff, .cchBuff, .wFlags, .dwhkl>,  'ToUnicodeEx',  \
    TrackMouseEvent, <.lpEventTrack>,  'TrackMouseEvent',  \
    TrackPopupMenu, <.hMenu, .uFlags, .x, .y, .nReserved, .hwnd, .lprc>,  'TrackPopupMenu',  \
    TrackPopupMenuEx, <.hMenu, .un, .n1, .n2, .hWnd, .lpTPMParams>,  'TrackPopupMenuEx',  \
    TranslateAccelerator, <.hwnd, .hAccTable, .lpMsg>,  'TranslateAccelerator',  \
    TranslateAcceleratorA, <.hwnd, .hAccTable, .lpMsg>,  'TranslateAcceleratorA',  \
    TranslateAcceleratorW, <.hwnd, .hAccTable, .lpMsg>,  'TranslateAcceleratorW',  \
    TranslateMDISysAccel, <.hWndClient, .lpMsg>,  'TranslateMDISysAccel',  \
    TranslateMessage, <.lpMsg>,  'TranslateMessage',  \
    TranslateMessageEx, <NONE>,  'TranslateMessageEx',  \
    UnhookWinEvent, <.hWinEventHook>,  'UnhookWinEvent',  \
    UnhookWindowsHook, <.nCode, .pfnFilterProc>,  'UnhookWindowsHook',  \
    UnhookWindowsHookEx, <.hHook>,  'UnhookWindowsHookEx',  \
    UnionRect, <.lpDestRect, .lpSrc1Rect, .lpSrc2Rect>,  'UnionRect',  \
    UnloadKeyboardLayout, <.HKL>,  'UnloadKeyboardLayout',  \
    UnlockWindowStation, <NONE>,  'UnlockWindowStation',  \
    UnpackDDElParam, <.msg, .lParam, .puiLo, .puiHi>,  'UnpackDDElParam',  \
    UnregisterClassA, <.lpClassName, .hInstance>,  'UnregisterClassA',  \
    UnregisterClassW, <.lpClassName, .hInstance>,  'UnregisterClassW',  \
    UnregisterDeviceNotification, <.Handle>,  'UnregisterDeviceNotification',  \
    UnregisterHotKey, <.hwnd, .id>,  'UnregisterHotKey',  \
    UnregisterMessagePumpHook, <NONE>,  'UnregisterMessagePumpHook',  \
    UnregisterUserApiHook, <NONE>,  'UnregisterUserApiHook',  \
    UpdateLayeredWindow, <.hWnd, .hdcDst, .pptDst, .psize, .hdcSrc, .pptSrc, .crKey, .pblend, .dwFlags>,  'UpdateLayeredWindow',  \
    UpdatePerUserSystemParameters, <NONE>,  'UpdatePerUserSystemParameters',  \
    UpdateWindow, <.hwnd>,  'UpdateWindow',  \
    User32InitializeImmEntryTable, <NONE>,  'User32InitializeImmEntryTable',  \
    UserClientDllInitialize, <NONE>,  'UserClientDllInitialize',  \
    UserHandleGrantAccess, <.hUserHandle, .hJob, .bGrant>,  'UserHandleGrantAccess',  \
    UserLpkPSMTextOut, <NONE>,  'UserLpkPSMTextOut',  \
    UserLpkTabbedTextOut, <NONE>,  'UserLpkTabbedTextOut',  \
    UserRealizePalette, <NONE>,  'UserRealizePalette',  \
    UserRegisterWowHandlers, <NONE>,  'UserRegisterWowHandlers',  \
    VRipOutput, <NONE>,  'VRipOutput',  \
    VTagOutput, <NONE>,  'VTagOutput',  \
    ValidateRect, <.hwnd, .lpRect>,  'ValidateRect',  \
    ValidateRgn, <.hwnd, .hRgn>,  'ValidateRgn',  \
    VkKeyScanA, <.cChar>,  'VkKeyScanA',  \
    VkKeyScanExA, <.ch, .dwhkl>,  'VkKeyScanExA',  \
    VkKeyScanExW, <.ch, .dwhkl>,  'VkKeyScanExW',  \
    VkKeyScanW, <.cChar>,  'VkKeyScanW',  \
    WCSToMBEx, <NONE>,  'WCSToMBEx',  \
    WINNLSEnableIME, <.hwnd, .bool>,  'WINNLSEnableIME',  \
    WINNLSGetEnableStatus, <.hwnd>,  'WINNLSGetEnableStatus',  \
    WINNLSGetIMEHotkey, <.hwnd>,  'WINNLSGetIMEHotkey',  \
    WaitForInputIdle, <.hProcess, .dwMilliseconds>,  'WaitForInputIdle',  \
    WaitMessage, <VOID>,  'WaitMessage',  \
    Win32PoolAllocationStats, <NONE>,  'Win32PoolAllocationStats',  \
    WinHelpA, <.hwnd, .lpHelpFile, .wCommand, .dwData>,  'WinHelpA',  \
    WinHelpW, <.hwnd, .lpHelpFile, .wCommand, .dwData>,  'WinHelpW',  \
    WindowFromDC, <.hdc>,  'WindowFromDC',  \
    WindowFromPoint, <.xPoint, .yPoint>,  'WindowFromPoint',  \
    keybd_event, <.bVk, .bScan, .dwFlags, .dwExtraInfo>,  'keybd_event',  \
    mouse_event, <.dwFlags, .dx, .dy, .cButtons, .dwExtraInfo>,  'mouse_event',  \
    wsprintfA, <.lpOut, .lpFmt, .etc>,  'wsprintfA',  \
    wsprintfW, <.lpOut, .lpFmt, .etc>,  'wsprintfW',  \
    wvsprintfA, <NONE>,  'wvsprintfA',  \
    wvsprintfW, <NONE>,  'wvsprintfW'
