; _______________________________________________________________________________________
;|                                                                                       |
;| ..::FreshLib::..  Free, open source. Licensed under "BSD 2-clause" license."          |
;|_______________________________________________________________________________________|
;
;  Description: Several data definition/manipulation macros.
;
;  Target OS: Any
;
;  Dependencies:
;
;  Notes:
;_________________________________________________________________________________________

macro getfile lblname*, filename* {
  if used lblname
    lblname file filename
    .size = $ - lblname
  end if
}

macro StringTable [string] {
  forward
    local ..lbl
    dd  ..lbl
  common
    dd  0
  forward
..lbl db string, 0
}


macro IndexedStrings [lparam, string] {
  forward
    local ..lbl
    dd  ..lbl, lparam
  common
    dd  0
  forward
..lbl db string, 0
}


macro Sequence [seqname*, initvalue*] {
forward
  seqname#.current = initvalue
  macro seqname [name] \{
    name = seqname#.current
    seqname#.current = seqname#.current + 1
    if defined seqname#.display & seqname#.display
      disp iconInfo, `seqname, ' value: ', \`#name, ' = $', <name, 16>, $0d
    end if
  \}
}
