uglobal
  hLister dd ?
  hSplitterLister dd ?
endg


proc InitListerWindow, .hParent
begin
        xor     ebx, ebx
        invoke   CreateWindowExA, ebx, cAsmEditClassName, NULL,          \
                 WS_CHILD or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL or   \
                 ES_NOHIDESEL or AES_AUTOINDENT or AES_SMARTTABS or AES_CONSOLECARET ,      \
                 ebx, ebx , 200, ebx,                                 \
                 [.hParent],                                           \
                 ebx, [hInstance],                                    \
                 NULL

        mov     [hLister], eax
        mov     ebx, eax

        mov     edi, [CurrentSettings]
        invoke  CreateFontA, [edi+TEditorSettings.FontSize], 0, 0, 0, FW_NORMAL,                 \
                            0, 0, 0, [edi+TEditorSettings.FontCharset],                         \
                            OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,           \
                            FIXED_PITCH or FF_DONTCARE, [edi+TEditorSettings.ptrFontName]

        invoke  SendMessageA, ebx, WM_SETFONT, eax, TRUE
        invoke  SendMessageA, ebx, AEM_SETTHEME, 0, [edi+TEditorSettings.ptrTheme]
        invoke  SendMessageA, ebx, AEM_SETMARGINWIDTH, 0, 0
        invoke  SendMessageA, ebx, AEM_SETBOOKMARKICON, [hBookmarkIcon], 0

        stdcall SetAlign, ebx, waRight
        stdcall SubclassWindow, ebx, ListerWinProc

        invoke  CreateWindowExA, 0, cSplitterClassName, NULL,            \
                WS_CLIPSIBLINGS or WS_CHILD,              \
                0, 0, 0, 0, [.hParent], NULL, [hInstance], [hLister]
        mov     [hSplitterLister], eax
        invoke  SendMessageA, eax, SPM_SETCURSORS, resVSplit, resHSplit
        return
endp




proc ListerWinProc, .hwnd, .wmsg, .wparam, .lparam
.minaddr dd ?
.maxaddr dd ?
.line    dd ?
.beg     dd ?
.end     dd ?
begin
        cmp     [.wmsg], LM_SHOWLIST
        je      .lmshowlist

        cmp     [.wmsg], LM_SHOW
        je      .lmshow

        stc
        return

;-------- LM_SHOW ----------------------
.lmshow:
        invoke  ShowWindow, [hSplitterLister], [.wparam]
        invoke  ShowWindow, [.hwnd], [.wparam]
        clc
        return

;-------- LM_SHOWLIST ------------------

.lmshowlist:
        mov     esi, [.wparam]
        mov     edi, [ptrDebugInfo]
        test    edi, edi
        jnz     .doprocess
        clc
        return

.doprocess:
        lea     eax, [edi+TArray.array]
        mov     ecx, [edi+TArray.count]

        dec     ecx
        mov     [.minaddr], eax
        imul    ecx, [edi+TArray.itemsize]
        add     eax, ecx
        mov     [.maxaddr], eax

        mov     [.line], 1

        mov     ecx, [esi+TDebugLine.ptrFile]
        mov     edx, [esi+TDebugLine.LineNum]

        stdcall StrNew
        mov     ebx, eax

.searchbegin:
        cmp     esi, [.minaddr]
        je      .begfound

        cmp     [esi+TDebugLine.ptrFile-sizeof.TDebugLine], ecx   ; check prev
        jne     .begfound

        cmp     [esi+TDebugLine.LineNum-sizeof.TDebugLine], edx
        jne     .begfound

        sub     esi, sizeof.TDebugLine
        inc     [.line]
        jmp     .searchbegin

.begfound:
        mov     [.beg], esi
        mov     esi, [.wparam]

.searchend:
        cmp     esi, [.maxaddr]
        je      .endfound
        cmp     dword [esi+TDebugLine.ptrFile+sizeof.TDebugLine], ecx   ; check next
        jne     .endfound
        cmp     [esi+TDebugLine.LineNum+sizeof.TDebugLine], edx
        jne     .endfound

        add     esi, sizeof.TDebugLine
        jmp     .searchend

.endfound:
        mov     [.end], esi
        mov     esi, [.beg]

.getloop:
        mov     eax, [esi+TDebugLine.strLine]
        add     eax, [ptrListing]

        stdcall StrCat, ebx, eax
        stdcall StrCharCat, ebx, $0d
        add     esi, sizeof.TDebugLine
        cmp     esi, [.end]
        jbe     .getloop

        stdcall StrPtr, ebx
        invoke  SendMessageA, [hLister], WM_SETTEXT, 0, eax
        stdcall StrDel, ebx

        invoke  SendMessageA, [hLister], AEM_SETFOCUSLINE, [.line], 0

        clc
        return
endp